/**
 * Khan API v0.7.2
 * https://khan-api.bhavjit.com
 * Licensed under MIT license
 * Copyright 2024 Bhavjit Chauhan
 */

"use strict";var KhanAPI=(()=>{var kt=Object.create;var Be=Object.defineProperty;var wt=Object.getOwnPropertyDescriptor;var _t=Object.getOwnPropertyNames;var Pt=Object.getPrototypeOf,Rt=Object.prototype.hasOwnProperty;var Hr=t=>{throw TypeError(t)};var St=(t,r)=>()=>(r||t((r={exports:{}}).exports,r),r.exports),yr=(t,r)=>{for(var e in r)Be(t,e,{get:r[e],enumerable:!0})},jr=(t,r,e,a)=>{if(r&&typeof r=="object"||typeof r=="function")for(let s of _t(r))!Rt.call(t,s)&&s!==e&&Be(t,s,{get:()=>r[s],enumerable:!(a=wt(r,s))||a.enumerable});return t};var xt=(t,r,e)=>(e=t!=null?kt(Pt(t)):{},jr(r||!t||!t.__esModule?Be(e,"default",{value:t,enumerable:!0}):e,t)),At=t=>jr(Be({},"__esModule",{value:!0}),t);var fr=(t,r,e)=>r.has(t)||Hr("Cannot "+e);var b=(t,r,e)=>(fr(t,r,"read from private field"),e?e.call(t):r.get(t)),U=(t,r,e)=>r.has(t)?Hr("Cannot add the same private member more than once"):r instanceof WeakSet?r.add(t):r.set(t,e),Ne=(t,r,e,a)=>(fr(t,r,"write to private field"),a?a.call(t,e):r.set(t,e),e),m=(t,r,e)=>(fr(t,r,"access private method"),e);var zr=St((X,Jr)=>{var $e=typeof globalThis<"u"&&globalThis||typeof self<"u"&&self||typeof global<"u"&&global,Ge=function(){function t(){this.fetch=!1,this.DOMException=$e.DOMException}return t.prototype=$e,new t}();(function(t){var r=function(e){var a=typeof t<"u"&&t||typeof self<"u"&&self||typeof a<"u"&&a,s={searchParams:"URLSearchParams"in a,iterable:"Symbol"in a&&"iterator"in Symbol,blob:"FileReader"in a&&"Blob"in a&&function(){try{return new Blob,!0}catch{return!1}}(),formData:"FormData"in a,arrayBuffer:"ArrayBuffer"in a};function n(o){return o&&DataView.prototype.isPrototypeOf(o)}if(s.arrayBuffer)var l=["[object Int8Array]","[object Uint8Array]","[object Uint8ClampedArray]","[object Int16Array]","[object Uint16Array]","[object Int32Array]","[object Uint32Array]","[object Float32Array]","[object Float64Array]"],p=ArrayBuffer.isView||function(o){return o&&l.indexOf(Object.prototype.toString.call(o))>-1};function k(o){if(typeof o!="string"&&(o=String(o)),/[^a-z0-9\-#$%&'*+.^_`|~!]/i.test(o)||o==="")throw new TypeError('Invalid character in header field name: "'+o+'"');return o.toLowerCase()}function x(o){return typeof o!="string"&&(o=String(o)),o}function w(o){var i={next:function(){var d=o.shift();return{done:d===void 0,value:d}}};return s.iterable&&(i[Symbol.iterator]=function(){return i}),i}function c(o){this.map={},o instanceof c?o.forEach(function(i,d){this.append(d,i)},this):Array.isArray(o)?o.forEach(function(i){this.append(i[0],i[1])},this):o&&Object.getOwnPropertyNames(o).forEach(function(i){this.append(i,o[i])},this)}c.prototype.append=function(o,i){o=k(o),i=x(i);var d=this.map[o];this.map[o]=d?d+", "+i:i},c.prototype.delete=function(o){delete this.map[k(o)]},c.prototype.get=function(o){return o=k(o),this.has(o)?this.map[o]:null},c.prototype.has=function(o){return this.map.hasOwnProperty(k(o))},c.prototype.set=function(o,i){this.map[k(o)]=x(i)},c.prototype.forEach=function(o,i){for(var d in this.map)this.map.hasOwnProperty(d)&&o.call(i,this.map[d],d,this)},c.prototype.keys=function(){var o=[];return this.forEach(function(i,d){o.push(d)}),w(o)},c.prototype.values=function(){var o=[];return this.forEach(function(i){o.push(i)}),w(o)},c.prototype.entries=function(){var o=[];return this.forEach(function(i,d){o.push([d,i])}),w(o)},s.iterable&&(c.prototype[Symbol.iterator]=c.prototype.entries);function B(o){if(o.bodyUsed)return Promise.reject(new TypeError("Already read"));o.bodyUsed=!0}function q(o){return new Promise(function(i,d){o.onload=function(){i(o.result)},o.onerror=function(){d(o.error)}})}function O(o){var i=new FileReader,d=q(i);return i.readAsArrayBuffer(o),d}function y(o){var i=new FileReader,d=q(i);return i.readAsText(o),d}function G(o){for(var i=new Uint8Array(o),d=new Array(i.length),_=0;_<i.length;_++)d[_]=String.fromCharCode(i[_]);return d.join("")}function we(o){if(o.slice)return o.slice(0);var i=new Uint8Array(o.byteLength);return i.set(new Uint8Array(o)),i.buffer}function Gr(){return this.bodyUsed=!1,this._initBody=function(o){this.bodyUsed=this.bodyUsed,this._bodyInit=o,o?typeof o=="string"?this._bodyText=o:s.blob&&Blob.prototype.isPrototypeOf(o)?this._bodyBlob=o:s.formData&&FormData.prototype.isPrototypeOf(o)?this._bodyFormData=o:s.searchParams&&URLSearchParams.prototype.isPrototypeOf(o)?this._bodyText=o.toString():s.arrayBuffer&&s.blob&&n(o)?(this._bodyArrayBuffer=we(o.buffer),this._bodyInit=new Blob([this._bodyArrayBuffer])):s.arrayBuffer&&(ArrayBuffer.prototype.isPrototypeOf(o)||p(o))?this._bodyArrayBuffer=we(o):this._bodyText=o=Object.prototype.toString.call(o):this._bodyText="",this.headers.get("content-type")||(typeof o=="string"?this.headers.set("content-type","text/plain;charset=UTF-8"):this._bodyBlob&&this._bodyBlob.type?this.headers.set("content-type",this._bodyBlob.type):s.searchParams&&URLSearchParams.prototype.isPrototypeOf(o)&&this.headers.set("content-type","application/x-www-form-urlencoded;charset=UTF-8"))},s.blob&&(this.blob=function(){var o=B(this);if(o)return o;if(this._bodyBlob)return Promise.resolve(this._bodyBlob);if(this._bodyArrayBuffer)return Promise.resolve(new Blob([this._bodyArrayBuffer]));if(this._bodyFormData)throw new Error("could not read FormData body as blob");return Promise.resolve(new Blob([this._bodyText]))},this.arrayBuffer=function(){if(this._bodyArrayBuffer){var o=B(this);return o||(ArrayBuffer.isView(this._bodyArrayBuffer)?Promise.resolve(this._bodyArrayBuffer.buffer.slice(this._bodyArrayBuffer.byteOffset,this._bodyArrayBuffer.byteOffset+this._bodyArrayBuffer.byteLength)):Promise.resolve(this._bodyArrayBuffer))}else return this.blob().then(O)}),this.text=function(){var o=B(this);if(o)return o;if(this._bodyBlob)return y(this._bodyBlob);if(this._bodyArrayBuffer)return Promise.resolve(G(this._bodyArrayBuffer));if(this._bodyFormData)throw new Error("could not read FormData body as text");return Promise.resolve(this._bodyText)},s.formData&&(this.formData=function(){return this.text().then(ft)}),this.json=function(){return this.text().then(JSON.parse)},this}var mt=["DELETE","GET","HEAD","OPTIONS","POST","PUT"];function yt(o){var i=o.toUpperCase();return mt.indexOf(i)>-1?i:o}function Z(o,i){if(!(this instanceof Z))throw new TypeError('Please use the "new" operator, this DOM object constructor cannot be called as a function.');i=i||{};var d=i.body;if(o instanceof Z){if(o.bodyUsed)throw new TypeError("Already read");this.url=o.url,this.credentials=o.credentials,i.headers||(this.headers=new c(o.headers)),this.method=o.method,this.mode=o.mode,this.signal=o.signal,!d&&o._bodyInit!=null&&(d=o._bodyInit,o.bodyUsed=!0)}else this.url=String(o);if(this.credentials=i.credentials||this.credentials||"same-origin",(i.headers||!this.headers)&&(this.headers=new c(i.headers)),this.method=yt(i.method||this.method||"GET"),this.mode=i.mode||this.mode||null,this.signal=i.signal||this.signal,this.referrer=null,(this.method==="GET"||this.method==="HEAD")&&d)throw new TypeError("Body not allowed for GET or HEAD requests");if(this._initBody(d),(this.method==="GET"||this.method==="HEAD")&&(i.cache==="no-store"||i.cache==="no-cache")){var _=/([?&])_=[^&]*/;if(_.test(this.url))this.url=this.url.replace(_,"$1_="+new Date().getTime());else{var S=/\?/;this.url+=(S.test(this.url)?"&":"?")+"_="+new Date().getTime()}}}Z.prototype.clone=function(){return new Z(this,{body:this._bodyInit})};function ft(o){var i=new FormData;return o.trim().split("&").forEach(function(d){if(d){var _=d.split("="),S=_.shift().replace(/\+/g," "),u=_.join("=").replace(/\+/g," ");i.append(decodeURIComponent(S),decodeURIComponent(u))}}),i}function gt(o){var i=new c,d=o.replace(/\r?\n[\t ]+/g," ");return d.split("\r").map(function(_){return _.indexOf(`
`)===0?_.substr(1,_.length):_}).forEach(function(_){var S=_.split(":"),u=S.shift().trim();if(u){var Me=S.join(":").trim();i.append(u,Me)}}),i}Gr.call(Z.prototype);function M(o,i){if(!(this instanceof M))throw new TypeError('Please use the "new" operator, this DOM object constructor cannot be called as a function.');i||(i={}),this.type="default",this.status=i.status===void 0?200:i.status,this.ok=this.status>=200&&this.status<300,this.statusText=i.statusText===void 0?"":""+i.statusText,this.headers=new c(i.headers),this.url=i.url||"",this._initBody(o)}Gr.call(M.prototype),M.prototype.clone=function(){return new M(this._bodyInit,{status:this.status,statusText:this.statusText,headers:new c(this.headers),url:this.url})},M.error=function(){var o=new M(null,{status:0,statusText:""});return o.type="error",o};var ht=[301,302,303,307,308];M.redirect=function(o,i){if(ht.indexOf(i)===-1)throw new RangeError("Invalid status code");return new M(null,{status:i,headers:{location:o}})},e.DOMException=a.DOMException;try{new e.DOMException}catch{e.DOMException=function(i,d){this.message=i,this.name=d;var _=Error(i);this.stack=_.stack},e.DOMException.prototype=Object.create(Error.prototype),e.DOMException.prototype.constructor=e.DOMException}function mr(o,i){return new Promise(function(d,_){var S=new Z(o,i);if(S.signal&&S.signal.aborted)return _(new e.DOMException("Aborted","AbortError"));var u=new XMLHttpRequest;function Me(){u.abort()}u.onload=function(){var F={status:u.status,statusText:u.statusText,headers:gt(u.getAllResponseHeaders()||"")};F.url="responseURL"in u?u.responseURL:F.headers.get("X-Request-URL");var Ve="response"in u?u.response:u.responseText;setTimeout(function(){d(new M(Ve,F))},0)},u.onerror=function(){setTimeout(function(){_(new TypeError("Network request failed"))},0)},u.ontimeout=function(){setTimeout(function(){_(new TypeError("Network request failed"))},0)},u.onabort=function(){setTimeout(function(){_(new e.DOMException("Aborted","AbortError"))},0)};function bt(F){try{return F===""&&a.location.href?a.location.href:F}catch{return F}}u.open(S.method,bt(S.url),!0),S.credentials==="include"?u.withCredentials=!0:S.credentials==="omit"&&(u.withCredentials=!1),"responseType"in u&&(s.blob?u.responseType="blob":s.arrayBuffer&&S.headers.get("Content-Type")&&S.headers.get("Content-Type").indexOf("application/octet-stream")!==-1&&(u.responseType="arraybuffer")),i&&typeof i.headers=="object"&&!(i.headers instanceof c)?Object.getOwnPropertyNames(i.headers).forEach(function(F){u.setRequestHeader(F,x(i.headers[F]))}):S.headers.forEach(function(F,Ve){u.setRequestHeader(Ve,F)}),S.signal&&(S.signal.addEventListener("abort",Me),u.onreadystatechange=function(){u.readyState===4&&S.signal.removeEventListener("abort",Me)}),u.send(typeof S._bodyInit>"u"?null:S._bodyInit)})}return mr.polyfill=!0,a.fetch||(a.fetch=mr,a.Headers=c,a.Request=Z,a.Response=M),e.Headers=c,e.Request=Z,e.Response=M,e.fetch=mr,e}({})})(Ge);Ge.fetch.ponyfill=!0;delete Ge.fetch.polyfill;var ue=$e.fetch?$e:Ge;X=ue.fetch;X.default=ue.fetch;X.fetch=ue.fetch;X.Headers=ue.Headers;X.Request=ue.Request;X.Response=ue.Response;Jr.exports=X});var Yt={};yr(Yt,{Answer:()=>de,BadgeCategory:()=>ut,BaseMessage:()=>W,Client:()=>g,EmailRegex:()=>Tr,EmailRegexMatch:()=>Bt,FeedbackFocusKind:()=>lr,FeedbackKeyRegex:()=>xr,FeedbackKeyRegexMatch:()=>Lt,FeedbackSort:()=>Dr,FeedbackType:()=>Ce,FeedbackTypename:()=>it,GoogleIDRegex:()=>Se,GoogleIDRegexMatch:()=>Mt,KaidRegex:()=>Ze,KaidRegexMatch:()=>Ut,ListProgramSortOrder:()=>Fr,MESSAGE_ENCRYPTED_KEY_LENGTHS:()=>qt,MESSAGE_KEY_LENGTHS:()=>Ct,Message:()=>R,MessageEncryptedKeyRegex:()=>Ar,MessageEncryptedKeyRegexMatch:()=>Ot,MessageType:()=>le,PROGRAM_ID_LENGTHS:()=>tt,PROGRAM_KEY_LENGTHS:()=>at,PROGRAM_URL_PATHS:()=>Pr,Program:()=>C,ProgramEditorType:()=>Kr,ProgramIDRegex:()=>Xe,ProgramIDRegexMatch:()=>_r,ProgramImagePathRegex:()=>Re,ProgramImagePathRegexMatch:()=>Dt,ProgramKeyRegex:()=>Sr,ProgramKeyRegexMatch:()=>Ft,ProgramType:()=>Or,ProgramURLRegex:()=>oe,ProgramURLRegexMatch:()=>Kt,QualarooIDRegex:()=>xe,QualarooIDRegexMatch:()=>Vt,Question:()=>L,Reply:()=>Y,ServiceErrorCode:()=>ot,ServiceErrorName:()=>st,TipsAndThanks:()=>J,TypeToMessageClass:()=>$r,URL_LOCALES:()=>wr,URL_TLDS:()=>kr,User:()=>V,UserAccessLevel:()=>nt,UserURLRegex:()=>fe,UserURLRegexMatch:()=>vt,assertDataResponse:()=>A,avatarNameToSlug:()=>Qt,avatarNames:()=>Mr,avatarSlugToName:()=>$t,avatarSlugs:()=>Vr,convertAvatarPNGToSVG:()=>Ht,convertAvatarSVGToPNG:()=>Gt,extractAvatarSlug:()=>Le,generateAvatarPNG:()=>ur,generateAvatarSVG:()=>cr,get:()=>Tt,getLatestFragment:()=>It,getLatestMutation:()=>hr,getLatestQuery:()=>He,getLatestQueryHash:()=>Et,graphql:()=>f,hashQuery:()=>Zr,http:()=>te,isAnswerSchema:()=>Wt,isDataResponse:()=>lt,isEmail:()=>K,isEncryptedFeedbackKey:()=>v,isFeedbackKey:()=>I,isGoogleID:()=>Ir,isInputErrorResponse:()=>pt,isKaid:()=>P,isProgramID:()=>ee,isProgramKey:()=>se,isProgramURL:()=>Rr,isQualarooID:()=>Er,isQuestionSchema:()=>Qr,isReplySchema:()=>jt,isServiceErrorsResponse:()=>dt,isTipsAndThanksSchema:()=>Nr,isUserURL:()=>ae,mutations:()=>vr,post:()=>br,programIDtoKey:()=>Nt,programKeyToID:()=>Cr,queries:()=>Ur,resolveFeedbackKey:()=>qr,resolveKaid:()=>pr,resolveProgramID:()=>he,resolveUsername:()=>Lr});var Ur={};yr(Ur,{AvatarDataForProfile:()=>je,FeedbackQuery:()=>We,GetFeedbackReplies:()=>Ye,GetFeedbackRepliesPage:()=>Je,GetFullUserProfile:()=>er,GetProfileWidgets:()=>rr,GetUserByUsernameOrEmail:()=>tr,GetUserHoverCardProfile:()=>ar,Hotlist:()=>or,ProgramQuery:()=>sr,ProjectsAuthoredByUser:()=>nr,QAExpandKeyInfo:()=>De,QaExpandKeyInfo:()=>ir,avatarDataForProfile:()=>_e,feedbackQuery:()=>me,getFeedbackReplies:()=>ye,getFeedbackRepliesPage:()=>Pe,getFullUserProfile:()=>Ae,getProfileWidgets:()=>Ie,getUserByUsernameOrEmail:()=>Ee,getUserHoverCardProfile:()=>Te,hotlist:()=>Ue,programQuery:()=>ve,projectsAuthoredByUser:()=>Ke});var h="https://www.khanacademy.org/api/internal/graphql",Qe="https://cdn.jsdelivr.net/gh/bhavjitChauhan/khan-api@safelist",Wr="khan-proxy.bhavjit.com",gr=`bhavjitchauhan/khan-api_${Date.now()}`,Yr=4669512406581248;var Xr=xt(zr(),1);async function He(t){let r=await te(`${Qe}/query/${t}`);return r.status===404?null:await r.text()}async function hr(t){let r=await te(`${Qe}/mutation/${t}`);return r.status===404?null:await r.text()}async function It(t){let r=await te(`${Qe}/fragment/${t}`);return r.status===404?null:await r.text()}function Zr(t){let r=5381,e=t.length;for(;e;)r=r*33^t.charCodeAt(--e);return r>>>0}async function Et(t){let r=await He(t);return r?Zr(r):null}async function te(t,r){return await(0,Xr.default)(t,r)}async function Tt(t,r){return r={method:"get",...r},await te(t,r)}async function br(t,r,e){return e={method:"post",body:JSON.stringify(r),...e},await te(t,e)}async function f(t,r,e={},a){let s={query:r,variables:e};typeof window<"u"&&window.location.hostname!=="khanacademy.org"&&(t=t.replace("www.khanacademy.org",Wr));let n=await br(t,s,a);if(n.status===403){let l=r.startsWith("query"),p=r.match(/^(?:query|mutation) (\w+)/)?.[1];if(!p)throw new Error("An unknown query is no longer in the safelist");console.warn(`The query for operation "${p}" is no longer in the safelist. Attempting to fetch the latest version from the safelist...`);let k=l?await He(p):await hr(p);if(!k)throw new Error(`The query for operation "${p}" was not found in the safelist`);return await br(t,{...s,query:k},a)}return n}var je;(r=>r.query=`query avatarDataForProfile($kaid: String!) {
  user(kaid: $kaid) {
    id
    avatar {
      name
      imageSrc
      __typename
    }
    __typename
  }
}`)(je||(je={}));function _e(t,r){return f(`${h}/avatarDataForProfile`,je.query,typeof t=="string"?{kaid:t}:t,r)}var We;(r=>r.query=`query feedbackQuery($topicId: String!, $focusKind: String!, $cursor: String, $limit: Int, $feedbackType: FeedbackType!, $currentSort: Int, $qaExpandKey: String) {
  feedback(
    focusId: $topicId
    cursor: $cursor
    limit: $limit
    feedbackType: $feedbackType
    focusKind: $focusKind
    sort: $currentSort
    qaExpandKey: $qaExpandKey
    answersLimit: 1
  ) {
    feedback {
      isLocked
      isPinned
      replyCount
      appearsAsDeleted
      author {
        id
        kaid
        nickname
        avatar {
          name
          imageSrc
          __typename
        }
        __typename
      }
      badges {
        name
        icons {
          smallUrl
          __typename
        }
        description
        __typename
      }
      content
      date
      definitelyNotSpam
      deleted
      downVoted
      expandKey
      feedbackType
      flaggedBy
      flaggedByUser
      flags
      focusUrl
      focus {
        kind
        id
        translatedTitle
        relativeUrl
        __typename
      }
      fromVideoAuthor
      key
      lowQualityScore
      notifyOnAnswer
      permalink
      qualityKind
      replyCount
      replyExpandKeys
      showLowQualityNotice
      sumVotesIncremented
      upVoted
      ... on QuestionFeedback {
        hasAnswered
        answers {
          isLocked
          isPinned
          replyCount
          appearsAsDeleted
          author {
            id
            kaid
            nickname
            avatar {
              name
              imageSrc
              __typename
            }
            __typename
          }
          badges {
            name
            icons {
              smallUrl
              __typename
            }
            description
            __typename
          }
          content
          date
          definitelyNotSpam
          deleted
          downVoted
          expandKey
          feedbackType
          flaggedBy
          flaggedByUser
          flags
          focusUrl
          focus {
            kind
            id
            translatedTitle
            relativeUrl
            __typename
          }
          fromVideoAuthor
          key
          lowQualityScore
          notifyOnAnswer
          permalink
          qualityKind
          replyCount
          replyExpandKeys
          showLowQualityNotice
          sumVotesIncremented
          upVoted
          __typename
        }
        isOld
        answerCount
        __typename
      }
      ... on AnswerFeedback {
        question {
          isLocked
          isPinned
          replyCount
          appearsAsDeleted
          author {
            id
            kaid
            nickname
            avatar {
              name
              imageSrc
              __typename
            }
            __typename
          }
          badges {
            name
            icons {
              smallUrl
              __typename
            }
            description
            __typename
          }
          content
          date
          definitelyNotSpam
          deleted
          downVoted
          expandKey
          feedbackType
          flaggedBy
          flaggedByUser
          flags
          focusUrl
          focus {
            kind
            id
            translatedTitle
            relativeUrl
            __typename
          }
          fromVideoAuthor
          key
          lowQualityScore
          notifyOnAnswer
          permalink
          qualityKind
          replyCount
          replyExpandKeys
          showLowQualityNotice
          sumVotesIncremented
          upVoted
          __typename
        }
        __typename
      }
      __typename
    }
    cursor
    isComplete
    sortedByDate
    __typename
  }
}`)(We||(We={}));function me(t,r){return f(`${h}/feedbackQuery`,We.query,t,r)}var Ye;(r=>r.query=`query getFeedbackReplies($postKey: String!) {
  feedbackReplies(feedbackKey: $postKey) {
    isLocked
    isPinned
    expandKey
    appearsAsDeleted
    author {
      id
      kaid
      nickname
      avatar {
        name
        imageSrc
        __typename
      }
      __typename
    }
    content
    date
    definitelyNotSpam
    deleted
    downVoted
    expandKey
    feedbackType
    flaggedBy
    flaggedByUser
    flags
    focusUrl
    fromVideoAuthor
    key
    lowQualityScore
    notifyOnAnswer
    permalink
    qualityKind
    replyCount
    replyExpandKeys
    showLowQualityNotice
    sumVotesIncremented
    upVoted
    __typename
  }
}`)(Ye||(Ye={}));function ye(t,r){return f(`${h}/getFeedbackReplies`,Ye.query,typeof t=="string"?{postKey:t}:t,r)}var Je;(r=>r.query=`query getFeedbackRepliesPage($postKey: String!, $cursor: String, $limit: Int!) {
  feedbackRepliesPaginated(feedbackKey: $postKey, cursor: $cursor, limit: $limit) {
    cursor
    isComplete
    feedback {
      isLocked
      isPinned
      expandKey
      appearsAsDeleted
      author {
        id
        kaid
        nickname
        avatar {
          name
          imageSrc
          __typename
        }
        __typename
      }
      content
      date
      definitelyNotSpam
      deleted
      downVoted
      expandKey
      feedbackType
      flaggedBy
      flaggedByUser
      flags
      focusUrl
      fromVideoAuthor
      key
      lowQualityScore
      notifyOnAnswer
      permalink
      qualityKind
      replyCount
      replyExpandKeys
      showLowQualityNotice
      sumVotesIncremented
      upVoted
      __typename
    }
    __typename
  }
}`)(Je||(Je={}));function Pe(t,r){return f(`${h}/getFeedbackRepliesPage`,Je.query,t,r)}function et(t,r,e="..."){return r=Math.max(0,r),t.length>r?t.slice(0,r-e.length)+e:t}function ze(t){return t.replace(/-/g,"+").replace(/_/g,"/")}function rt(t){return t.replace(/\+/g,"-").replace(/\//g,"_").replace(/=/g,"")}function N(t){return new RegExp(`(${t.source.slice(1,-1)})`)}var kr=["com","org"],wr=["as","az","cs","da","el","gu","hu","id","it","lt","ja","kk","kn","ky","lv","mn","mr","my","nl","pt-pt","ru","sv","ta","uz","bg","bn","de","en","es","fr","hi","hy","ka","km","ko","nb","pa","pl","pt","ro","sr","tr","vi","zh-hans","sgn-us"],Ze=/^kaid_\d{20,25}$/,Ut=N(Ze),P=t=>Ze.test(t),fe=new RegExp(`^https?:\\/\\/(?:(?:www|${wr.join("|")})\\.)?khanacademy\\.(?:${kr.join("|")})\\/profile\\/((?!kaid_|kaid_\\D)\\w+|(?:${Ze.toString().slice(2,-2)}))(?:\\/.*)?$`,"i"),vt=N(fe),ae=t=>fe.test(t),tt=[9,10,16],Xe=new RegExp(`^[1-9](?:(?:${tt.map(t=>`\\d{${t-1}}`).join("|")}))$`),_r=new RegExp(`(?:^|\\D)(${Xe.source.slice(1,-1)})(?:$|\\D)`);function ee(t){return Xe.test(t.toString())}var Pr=["computer-programming","cs","pixar","nasa","piab-sandbox","computer-science","hour-of-code","math","differential-equations","electrical-engineering","mcat","apchem-topic","chemistry","art-history-basics","biology"],oe=new RegExp(`^https?:\\/\\/(?:(?:www|${wr.join("|")})\\.)?khanacademy\\.(?:${kr.join("|")})\\/(?:${Pr.join("|")})\\/[\\w\\d-.~()'!*:@,;]+\\/(${Xe.toString().slice(2,-2)})$`,"i"),Kt=N(oe);function Rr(t){return oe.test(t)}var Re=new RegExp(`^\\/(?:${Pr.join("|")})\\/[\\w\\d-.~()'!*:@,;]+\\/\\d+\\/(\\d+)\\.png$`),Dt=N(Re),at=[51,54],Sr=/^ag5zfmtoYW4tYWNhZGVteXI(?:U|X)CxIKU2NyYXRjaHBhZB(?:i|j)(?=[\w-]*$)(?:.{7}w|.{9}C(?:g|w|A|Q)w)$/,Ft=N(Sr);function se(t){if(at.includes(t.length)||!Sr.test(t))return!1;try{return atob(ze(t)),!0}catch{return!1}}var Ct=[106,107,108,110,111],xr=/^ag5zfmtoYW4tYWNhZGVteX(?:I|J)(?:A|B|7|9|-|_)CxIIVXNlckRhdGEi(?:Gm|GG|G2|Hm|HG|HW)thaWRf(?:M|N|O)(?:\w{34}|\w{29,31}|\w{27})(?:LEghGZWVkYmFjaxiAg[I-P](?:O|P|W|X|2|3)|DAsSCEZlZWRiYWNrGICA|MCxIIRmVlZGJhY2sYgI(?:C|D)|wLEghGZWVkYmFjaxiAg|DAsSCEZlZWRiYWNrGICA)(?:[\w-]{5}|[\w-]{7,8})(?:M|DA|C(?:g|w|A|Q)w)$/,Lt=N(xr),I=t=>xr.test(t),qt=[301],Ar=/^kaencrypted_[a-z0-9]{32}_[a-z0-9]{256}$/,Ot=N(Ar),v=t=>Ar.test(t),Se=/^http:\/\/googleid\.khanacademy\.org\/(\d+)$/,Mt=N(Se),Ir=t=>Se.test(t),xe=/^_gae_bingo_random:(\w+-\w+-\w+)$/,Vt=N(xe),Er=t=>xe.test(t),Tr=/^[a-zA-Z0-9.!#$%&’*+/=?^_`{|}~-]+@[a-zA-Z0-9-]+(?:\.[a-zA-Z0-9-]+)*$/,Bt=N(Tr),K=t=>Tr.test(t);var er;(r=>r.query=`query getFullUserProfile($kaid: String, $username: String) {
  user(kaid: $kaid, username: $username) {
    id
    kaid
    key
    userId
    email
    username
    profileRoot
    gaUserId
    isPhantom
    isDeveloper: hasPermission(name: "can_do_what_only_admins_can_do")
    isPublisher: hasPermission(name: "can_publish", scope: ANY_ON_CURRENT_LOCALE)
    isModerator: hasPermission(name: "can_moderate_users", scope: GLOBAL)
    isParent
    isTeacher
    isFormalTeacher
    isK4dStudent
    isKmapStudent
    isDataCollectible
    isChild
    isOrphan
    isCoachingLoggedInUser
    canModifyCoaches
    nickname
    hideVisual
    joined
    points
    countVideosCompleted
    bio
    profile {
      accessLevel
      __typename
    }
    soundOn
    muteVideos
    showCaptions
    prefersReducedMotion
    noColorInVideos
    newNotificationCount
    canHellban: hasPermission(name: "can_ban_users", scope: GLOBAL)
    canMessageUsers: hasPermission(
      name: "can_send_moderator_messages"
      scope: GLOBAL
    )
    isSelf: isActor
    hasStudents: hasCoachees
    hasClasses
    hasChildren
    hasCoach
    badgeCounts
    homepageUrl
    isMidsignupPhantom
    includesDistrictOwnedData
    includesKmapDistrictOwnedData
    includesK4dDistrictOwnedData
    canAccessDistrictsHomepage
    preferredKaLocale {
      id
      kaLocale
      status
      __typename
    }
    underAgeGate {
      parentEmail
      daysUntilCutoff
      approvalGivenAt
      __typename
    }
    authEmails
    signupDataIfUnverified {
      email
      emailBounced
      __typename
    }
    pendingEmailVerifications {
      email
      __typename
    }
    hasAccessToAIGuideTeacher
    hasAccessToAIGuideDistrictAdmin
    tosAccepted
    shouldShowAgeCheck
    birthMonthYear
    lastLoginCountry
    region
    userDistrictInfos {
      id
      isKAD
      district {
        id
        region
        __typename
      }
      __typename
    }
    schoolAffiliation {
      id
      location
      __typename
    }
    __typename
  }
  actorIsImpersonatingUser
  isAIGuideEnabled
  hasAccessToAIGuideDev
}`)(er||(er={}));function Ae(t,r){return f(`${h}/getFullUserProfile`,er.query,typeof t=="string"?P(t)?{kaid:t}:{username:t}:t,r)}var rr;(r=>r.query=`query getProfileWidgets($kaid: String!) {
  user(kaid: $kaid) {
    id
    kaid
    badgeCounts
    isChild
    profile {
      programs {
        id
        authorKaid
        authorNickname
        deleted
        displayableSpinoffCount
        imagePath
        key
        sumVotesIncremented
        translatedTitle: title
        url
        __typename
      }
      __typename
    }
    programs(sort: TOP, pageInfo: {itemsPerPage: 2}) {
      programs {
        id
        authorKaid
        authorNickname
        deleted
        displayableSpinoffCount
        imagePath
        key
        sumVotesIncremented
        translatedTitle: title
        url
        __typename
      }
      __typename
    }
    __typename
  }
  userSummary(kaid: $kaid) {
    statistics {
      answers
      comments
      flags
      projectanswers
      projectquestions
      questions
      replies
      votes
      __typename
    }
    __typename
  }
}`)(rr||(rr={}));function Ie(t,r){return f(`${h}/getProfileWidgets`,rr.query,typeof t=="string"&&P(t)?{kaid:t}:t,r)}var tr;(r=>r.query=`query getUserByUsernameOrEmail($username: String, $email: String) {
  user(username: $username, email: $email) {
    id
    kaid
    __typename
  }
}`)(tr||(tr={}));function Ee(t,r){return f(`${h}/getUserByUsernameOrEmail`,tr.query,typeof t=="string"?K(t)?{email:t}:{username:t}:t,r)}var ar;(r=>r.query=`query getUserHoverCardProfile($kaid: String!) {
  user(kaid: $kaid) {
    id
    nickname
    username
    bio
    avatar {
      name
      imageSrc
      __typename
    }
    points
    isPhantom
    isActor
    isCoachedByActor
    userSummaryIsVisibleToActor
    actorHasUserScopedPermission(capability: CAN_VIEW_USER_IDENTITY)
    __typename
  }
}`)(ar||(ar={}));function Te(t,r){return f(`${h}/getUserHoverCardProfile`,ar.query,typeof t=="string"?{kaid:t}:t,r)}var or;(r=>r.query=`query hotlist($curationNodeId: String, $onlyOfficialProjectSpinoffs: Boolean!, $sort: ListProgramSortOrder, $pageInfo: ListProgramsPageInfo, $userAuthoredContentTypes: [UserAuthoredContentType!]) {
  listTopPrograms(
    curationNodeId: $curationNodeId
    onlyOfficialProjectSpinoffs: $onlyOfficialProjectSpinoffs
    sort: $sort
    pageInfo: $pageInfo
    userAuthoredContentTypes: $userAuthoredContentTypes
  ) {
    complete
    cursor
    programs {
      id
      key
      authorKaid
      authorNickname
      displayableSpinoffCount
      imagePath
      sumVotesIncremented
      translatedTitle: title
      url
      userAuthoredContentType
      __typename
    }
    __typename
  }
}`)(or||(or={}));function Ue(t,r){return f(`${h}/hotlist`,or.query,t,r)}var sr;(r=>r.query=`query programQuery($programId: String!) {
  programById(id: $programId) {
    byChild
    category
    created
    creatorProfile: author {
      id
      nickname
      profileRoot
      profile {
        accessLevel
        __typename
      }
      __typename
    }
    deleted
    description
    spinoffCount: displayableSpinoffCount
    docsUrlPath
    flags
    flaggedBy: flaggedByKaids
    flaggedByUser: isFlaggedByCurrentUser
    height
    hideFromHotlist
    id
    imagePath
    isProjectOrFork: originIsProject
    isOwner
    kaid: authorKaid
    key
    newUrlPath
    originScratchpad: originProgram {
      deleted
      translatedTitle
      url
      __typename
    }
    restrictPosting
    revision: latestRevision {
      id
      code
      configVersion
      created
      editorType
      folds
      __typename
    }
    slug
    sumVotesIncremented
    title
    topic: parentCurationNode {
      id
      nodeSlug: slug
      relativeUrl
      slug
      translatedTitle
      __typename
    }
    translatedTitle
    url
    userAuthoredContentType
    upVoted
    width
    __typename
  }
}`)(sr||(sr={}));function ve(t,r){return f(`${h}/programQuery`,sr.query,typeof t=="number"?{programId:t.toString()}:typeof t=="string"?{programId:t}:t,r)}var nr;(r=>r.query=`query projectsAuthoredByUser($kaid: String, $pageInfo: ListProgramsPageInfo, $sort: ListProgramSortOrder) {
  user(kaid: $kaid) {
    id
    programs(pageInfo: $pageInfo, sort: $sort) {
      complete
      cursor
      programs {
        id
        key
        authorKaid
        authorNickname
        displayableSpinoffCount
        imagePath
        sumVotesIncremented
        translatedTitle: title
        url
        __typename
      }
      __typename
    }
    __typename
  }
}`)(nr||(nr={}));function Ke(t,r){return f(`${h}/projectsAuthoredByUser`,nr.query,t,r)}var ir;(r=>r.query=`query QAExpandKeyInfo($encryptedKey: String) {
  qaExpandKeyInfo(encryptedQaExpandKey: $encryptedKey) {
    feedbackType
    unencryptedKey
    __typename
  }
}`)(ir||(ir={}));function De(t,r){return f(`${h}/QAExpandKeyInfo`,ir.query,typeof t=="string"?{encryptedKey:t}:t,r)}var vr={};yr(vr,{LoginWithPasswordMutation:()=>ne,loginWithPasswordMutation:()=>Fe});var ne;(e=>{e.query=`mutation loginWithPasswordMutation($identifier: String!, $password: String!) {
  loginWithPassword(identifier: $identifier, password: $password) {
    user {
      id
      kaid
      canAccessDistrictsHomepage
      isTeacher
      hasUnresolvedInvitations
      transferAuthToken
      preferredKaLocale {
        id
        kaLocale
        status
        __typename
      }
      __typename
    }
    isFirstLogin
    error {
      code
      __typename
    }
    __typename
  }
}`;let r;(n=>(n.INVALID_CREDENTIALS="INVALID_CREDENTIALS",n.TOO_MANY_ATTEMPTS="TOO_MANY_ATTEMPTS"))(r=e.ErrorCode||(e.ErrorCode={}))})(ne||(ne={}));function Fe(t,r){return f(`${h}/loginWithPasswordMutation`,ne.query,t,{headers:{"x-ka-fkey":gr,Cookie:`fkey=${gr}`},...r})}var H=class{constructor(r,e){return r instanceof g?this.client=r:e??(e=r),e&&this.copy(e),this}copy(r){return Object.assign(this,r),this}copyFromSchema(r){return this.rawData={...this.rawData,...r},this.copy(this.transformSchema(r))}isSchema(r){return this.is(this.transformSchema(r))}};var ot=(r=>(r.DOWNSTREAM_SERVICE_ERROR="DOWNSTREAM_SERVICE_ERROR",r))(ot||{}),st=(r=>(r.users="users",r))(st||{}),nt=(e=>(e.COACH="COACH",e.PUBLIC="PUBLIC",e))(nt||{}),Kr=(s=>(s.pjs="pjs",s.webpage="webpage",s.ace_sql="ace_sql",s.unknown="",s))(Kr||{}),lr=(n=>(n.Challenge="Challenge",n.Interactive="Interactive",n.Project="Project",n.Scratchpad="Scratchpad",n.Talkthrough="Talkthrough",n))(lr||{}),Ce=(y=>(y.ALL_PROJECT_ANSWER="ALL_PROJECT_ANSWER",y.ALL_PROJECT_QUESTION="ALL_PROJECT_QUESTION",y.ANSWER="ANSWER",y.COMMENT="COMMENT",y.PROGRAM="PROGRAM",y.PROJECTFEEDBACK="PROJECTFEEDBACK",y.PROJECT_CRITIQUE_ANSWER="PROJECT_CRITIQUE_ANSWER",y.PROJECT_CRITIQUE_QUESTION="PROJECT_CRITIQUE_QUESTION",y.PROJECT_EVAL_ANSWER="PROJECT_EVAL_ANSWER",y.PROJECT_EVAL_QUESTION="PROJECT_EVAL_QUESTION",y.PROJECT_HELP_ANSWER="PROJECT_HELP_ANSWER",y.PROJECT_HELP_QUESTION="PROJECT_HELP_QUESTION",y.QUESTION="QUESTION",y.REPLY="REPLY",y.SUGGESTED_CLARIFICATION="SUGGESTED_CLARIFICATION",y))(Ce||{}),it=(s=>(s.AnswerFeedback="AnswerFeedback",s.BasicFeedback="BasicFeedback",s.LowQualityFeedback="LowQualityFeedback",s.QuestionFeedback="QuestionFeedback",s))(it||{}),Dr=(a=>(a[a.TopVoted=1]="TopVoted",a[a.Recent=2]="Recent",a[a.Trending=5]="Trending",a))(Dr||{}),Fr=(l=>(l.TOP="TOP",l.RECENT="RECENT",l.HOT="HOT",l.OFFICIAL="OFFICIAL",l.UPVOTE="UPVOTE",l.OLDEST="OLDEST",l))(Fr||{});var re,ge,dr=class dr extends H{constructor(){super(...arguments);U(this,re)}get url(){return this.kaid?`https://www.khanacademy.org/profile/${this.username??this.kaid}`:null}static fromSchema(e){let a=new dr;return a.copyFromSchema(e),a.rawData=e,a}static fromIdentifier(e){return new dr({kaid:P(e)?e:void 0,username:!P(e)&&!K(e)?e:void 0,email:K(e)?e:void 0})}transformSchema(e){return{emails:e.authEmails??void 0,badgeCounts:e.badgeCounts?JSON.parse(e.badgeCounts):void 0,bio:e.bio??void 0,canAccessDistrictsHomepage:e.canAccessDistrictsHomepage??void 0,canHellban:e.canHellban??void 0,canMessageUsers:e.canMessageUsers??void 0,canModifyCoaches:e.canModifyCoaches??void 0,completedVideos:e.countVideosCompleted,email:e.email??void 0,hasAccessToAIGuideDev:e.hasAccessToAIGuideDev??void 0,hasAccessToAIGuideTeacher:e.hasAccessToAIGuideTeacher??void 0,hasChildren:e.hasChildren??void 0,hasClasses:e.hasClasses??void 0,hasCoach:e.hasCoach??void 0,hasStudents:e.hasStudents??void 0,child:e.isChild??void 0,creator:e.isCreator??void 0,curator:e.isCurator??void 0,developer:e.isDeveloper??void 0,midsignupPhantom:e.isMidsignupPhantom??void 0,moderator:e.isModerator??void 0,orphan:e.isOrphan??void 0,parent:e.isParent??void 0,phantom:e.isPhantom??void 0,publisher:e.isPublisher??void 0,self:e.isSelf??void 0,teacher:e.isTeacher??void 0,formalTeacher:e.isFormalTeacher??void 0,joined:e.joined?new Date(e.joined):void 0,kaid:typeof e.kaid=="string"&&P(e.kaid)?e.kaid:typeof e.kaid=="string"?null:void 0,key:e.key??void 0,newNotifications:e.newNotificationCount??void 0,nickname:e.nickname??void 0,points:e.points??void 0,accessLevel:e.profile?.accessLevel,googleID:typeof e.userId=="string"&&Ir(e.userId)?e.userId.match(Se)[1]:typeof e.userId=="string"?null:void 0,qualarooID:typeof e.qualarooId=="string"&&Er(e.qualarooId)?e.qualarooId.match(xe)[1]:typeof e.qualarooId=="string"?null:void 0,username:e.username??(e.profileRoot?P(e.profileRoot.slice(9,-1))?null:e.profileRoot.slice(9,-1):e.username)}}async get(e=this.client??new g){let a=await e.getUser(m(this,re,ge).call(this));return this.copy(a)}async getAvatar(e=this.client??new g){let a=await e.getUserAvatar(m(this,re,ge).call(this));return this.copy({avatar:a}),a}async getStatistics(e=this.client??new g){let a=await e.getUserStatistics(m(this,re,ge).call(this));return this.copy({statistics:a})}async*getPrograms(e=this.client??new g,a,s){for await(let n of e.getUserPrograms(m(this,re,ge).call(this),a,s))this.programs||this.copy({programs:[]}),this.programs?.push(...n),yield n;return this}async getAllPrograms(e=this.client??new g,a,s){let n=await e.getAllUserPrograms(m(this,re,ge).call(this),a,s);return this.copy({programs:n})}is(e){return!(this.kaid&&e.kaid)&&!(this.email&&e.email)&&!(this.key&&e.key)&&!(this.username&&e.username)&&!(this.googleID&&e.googleID)&&!(this.qualarooID&&e.qualarooID)?(console.warn("Users don't have any identifiers that can be compared"),!1):this.kaid&&e.kaid&&this.kaid===e.kaid||this.email&&e.email&&this.email===e.email||this.key&&e.key&&this.key===e.key||this.username&&e.username&&this.username===e.username||this.googleID&&e.googleID&&this.googleID===e.googleID||this.qualarooID&&e.qualarooID&&this.qualarooID===e.qualarooID||!1}};re=new WeakSet,ge=function(){if(this.kaid)return this.kaid;if(this.username)return this.username;if(this.email)return this.email;throw new Error("User has no identifier")};var V=dr;function lt(t){return"data"in t&&!("errors"in t)}function dt(t){return"errors"in t&&Array.isArray(t.errors)&&"data"in t}function pt(t){return"errors"in t&&Array.isArray(t.errors)&&!("data"in t)}function A(t){if(dt(t))throw new Error("Expected data response but got service errors response: "+t.errors.map(r=>r.message).join(", "));if(pt(t))throw new Error("Expected data response but got input errors response: "+t.errors.map(r=>r.message).join(", "));if(!lt(t))throw new Error("Expected data response but got unknown response")}function Cr(t){if(!se(t))throw new Error("Invalid program key");let r=atob(ze(t)).split("").map(s=>s.charCodeAt(0)),e=r[17];if(e===20)r=r.slice(32,37);else if(e===23)r=r.slice(34,40);else throw new Error(`Unknown program key version: ${e}`);let a=0n;for(let s=0;s<r.length;s++)a|=BigInt(r[s]&127)<<BigInt(s*7);return Number(e===20?a:a<<14n)}function Nt(t){if(!ee(t))throw new Error("Invalid program ID");typeof t=="string"&&(t=parseInt(t));let r=t.toString(2).match(/.{1,7}(?=(.{7})*$)/g).map(a=>String.fromCharCode(parseInt(a.length===7?`1${a}`:a,2))).reverse().join(""),e=btoa(`js~khan-academyr${r.length===5?"":""}\v
Scratchpad${r}\f`);return e=rt(e),e}async function pr(t){if(P(t))return t;if(P(`kaid_${t}`))return`kaid_${t}`;if(ae(t)){let s=t.match(fe);if(!s)throw new Error("Invalid user URL");if(t=s[1],P(t))return t}let e=await(await Ee(t)).json();if(A(e),!e.data.user)throw new Error("User not found");let a=e.data.user.kaid;if(!P(a))throw new Error("Invalid KAID");return a}async function Lr(t){if(!P(t)&&!K(t)&&!ae(t))return t;if(ae(t)){let a=t.match(fe);if(!a)throw new Error("Invalid user URL");if(t=a[1],!P(t)&&!K(t))return t}P(t)||(t=await pr(t));let e=await(await Te(t)).json();if(A(e),!e.data.user)throw new Error("User not found");return e.data.user.username}function he(t){if(typeof t=="number"){if(!ee(t))throw new Error("Invalid program ID");return t}else if(Rr(t)){let r=t.match(oe)[1];if(!ee(r))throw new Error("Invalid program URL");return parseInt(r,10)}else if(se(t)){if(t=Cr(t),!ee(t))throw new Error("Invalid program key");return t}else if(typeof t=="string"){if(!ee(t))throw new Error("Invalid program ID");return parseInt(t,10)}throw new Error("Invalid program identifier")}async function qr(t){if(I(t))return t;if(!v(t))throw new Error("Invalid encrypted message key");let e=await(await De(t)).json();if(A(e),!e.data.qaExpandKeyInfo)throw new Error("Message key not found");return e.data.qaExpandKeyInfo.unencryptedKey}var Or=(s=>(s.ProcessingJS="pjs",s.HTML="webpage",s.SQL="ace_sql",s.Other="",s))(Or||{}),j,ie,Q=class Q extends H{constructor(){super(...arguments);U(this,j)}get spinoff(){return typeof this.origin<"u"?!!this.origin:null}get lines(){return this.code?this.code.split(`
`).length:null}get url(){return this.rawData?.url?`https://www.khanacademy.org${this.rawData.url}`:this.id?`https://www.khanacademy.org/computer-programming/-/${this.id}`:null}get shortUrl(){return this.id?`https://khanacademy.org/cs/-/${this.id}`:null}get thumbnailUrl(){return this.rawData?.imagePath?`https://www.khanacademy.org${this.rawData.imagePath}`:this.thumbnailID&&this.url?`${this.url}/${this.thumbnailID}.png`:null}static fromSchema(e){let a=new Q;return a.copyFromSchema(e),a.rawData=e,a}static fromIdentifier(e){let a=he(e);return new Q({id:a,key:typeof e=="string"&&se(e)?e:void 0})}transformSchema(e){return{id:e.id?parseInt(e.id,10):void 0,title:e.translatedTitle,author:e.authorKaid||e.authorNickname||e.creatorProfile?V.fromSchema({kaid:e.authorKaid,nickname:e.authorNickname,isChild:e.byChild??void 0,...e.creatorProfile}):void 0,created:(()=>{if(e.created)return e.revision?.created?new Date(Math.min(new Date(e.created).valueOf(),new Date(e.revision.created).valueOf())):new Date(e.created)})(),updated:(()=>{if(e.revision?.created)return e.created&&e.revision.created===e.created?null:new Date(e.revision.created)})(),width:e.width,height:e.height,votes:e.sumVotesIncremented,spinOffCount:e.spinoffCount??e.displayableSpinoffCount,code:e.revision?.code,hidden:e.hideFromHotlist,type:(()=>{switch(e.revision?.editorType){case"pjs":return Q.Type.ProcessingJS;case"webpage":return Q.Type.HTML;case"ace_sql":return Q.Type.SQL;default:return Q.Type.Other}})(),origin:(()=>{if(!e.originScratchpad)return e.originScratchpad;let a=("https://khanacademy.org"+e.originScratchpad.url).match(oe)?.[1];if(!a){console.error(`Failed to parse origin program ID from URL: ${e.originScratchpad.url}`);return}return new Q({id:parseInt(a,10),title:e.originScratchpad.translatedTitle,deleted:e.originScratchpad.deleted})})(),key:e.key,thumbnailID:e.imagePath&&Re.test(e.imagePath)?parseInt(e.imagePath.match(Re)[1],10):void 0,description:typeof e.description=="string"?e.description!==""?e.description:null:e.description,deleted:e.deleted??void 0,selfFlagged:e.flaggedByUser,selfVoted:e.upVoted}}async get(e=this.client??new g){if(!this.id&&!this.key)throw new Error("Program is missing ID and key");let a=await e.getProgram(this.id??this.key);return this.copy(a)}async*getTipsAndThanks(e=this.client??new g,a){for await(let s of e.getProgramTipsAndThanks(m(this,j,ie).call(this),a))this.tipsAndThanks||this.copy({tipsAndThanks:[]}),s.forEach(n=>this.tipsAndThanks?.push(n)),yield s;return this}async getAllTipsAndThanks(e=this.client??new g,a){let s=await e.getAllProgramTipsAndThanks(m(this,j,ie).call(this),a);return this.copy({tipsAndThanks:s})}async*getQuestions(e=this.client??new g,a){for await(let s of e.getProgramQuestions(m(this,j,ie).call(this),a))this.questions||this.copy({questions:[]}),s.forEach(n=>this.questions.push(n)),yield s;return this}async getAllQuestions(e=this.client??new g,a){let s=await e.getAllProgramQuestions(m(this,j,ie).call(this),a);return this.copy({questions:s})}async*getHelpRequests(e=this.client??new g,a){for await(let s of e.getProgramHelpRequests(m(this,j,ie).call(this),a))this.helpRequests||this.copy({helpRequests:[]}),s.forEach(n=>this.helpRequests.push(n)),yield s;return this}async getAllHelpRequests(e=this.client??new g,a){let s=await e.getAllProgramHelpRequests(m(this,j,ie).call(this),a);return this.copy({helpRequests:s})}is(e){return!(this.id&&e.id)&&!(this.key&&e.key)?(console.warn("Programs don't have any identifiers that can be compared"),!1):this.id&&e.id&&this.id===e.id||this.key&&e.key&&this.key===e.key||!1}};j=new WeakSet,ie=function(){if(this.id)return this.id;if(this.key)return this.key;throw new Error("Program has no identifier")},Q.Type=Or;var C=Q;var Mr=["blobby_green_style","blobby_yellow_style","blobby_blue_style","blobby_purple_style","area_52_yellow_style","area_52_blue_style","area_52_green_style","area_52_purple_style","eggleston_blue_style","eggleston_yellow_style","eggleston_green_style","eggleston_orange_style","scuttlebug_purple_style","scuttlebug_yellow_style","scuttlebug_blue_style","scuttlebug_green_style","boggle_yellow_style","boggle_blue_style","boggle_green_style","boggle_purple_style","sneak_peak_green_style","sneak_peak_yellow_style","sneak_peak_blue_style","sneak_peak_purple_style","stelly_blue_style","stelly_yellow_style","stelly_green_style","stelly_orange_style","cacteye_purple_style","cacteye_yellow_style","cacteye_blue_style","cacteye_green_style","leaf_green_style","leaf_blue_style","leaf_grey_style","leaf_red_style","leaf_orange_style","leaf_yellow_style","leafers_seed_style","leafers_seedling_style","leafers_sapling_style","leafers_tree_style","leafers_ultimate_style","piceratops_seed_style","piceratops_seedling_style","piceratops_sapling_style","piceratops_tree_style","piceratops_ultimate_style","duskpin_seed_style","duskpin_seedling_style","duskpin_sapling_style","duskpin_tree_style","duskpin_ultimate_style","primosaur_seed_style","primosaur_seedling_style","primosaur_sapling_style","primosaur_tree_style","primosaur_ultimate_style","starky_seed_style","starky_seedling_style","starky_sapling_style","starky_tree_style","starky_ultimate_style","aqualine_seed_style","aqualine_seedling_style","aqualine_sapling_style","aqualine_tree_style","aqualine_ultimate_style","spunky_sam_blue_style","spunky_sam_green_style","spunky_sam_orange_style","spunky_sam_red_style","marcimus_pink_style","marcimus_orange_style","marcimus_red_style","marcimus_purple_style","mr_pink_red_style","mr_pink_green_style","mr_pink_orange_style","female_robot_amelia_style","female_robot_ada_style","female_robot_grace_style","male_robot_johnny_style","male_robot_donald_style","male_robot_hal_style","orange_juice_squid_orange_style","purple_pi_purple_style","purple_pi_pink_style","purple_pi_teal_style","mr_pants_teal_style","mr_pants_green_style","mr_pants_orange_style","mr_pants_pink_style","mr_pants_purple_style","old_spice_man_green_style","old_spice_man_blue_style","winston_default_style","winston_baby_style","ohnoes_default_style","hopper_happy_style","hopper_jumping_style","hopper_cool_style"],Vr=["blobby-green","blobby-yellow","blobby-blue","blobby-purple","area-52-yellow","area-52-blue","area-52-green","area-52-purple","eggleston-blue","eggleston-yellow","eggleston-green","eggleston-orange","scuttlebug-purple","scuttlebug-yellow","scuttlebug-blue","scuttlebug-green","boggle-yellow","boggle-blue","boggle-green","boggle-purple","sneak-peak-green","sneak-peak-yellow","sneak-peak-blue","sneak-peak-purple","stelly-blue","stelly-yellow","stelly-green","stelly-orange","cacteye-purple","cacteye-yellow","cacteye-blue","cacteye-green","leaf-green","leaf-blue","leaf-grey","leaf-red","leaf-orange","leaf-yellow","leafers-seed","leafers-seedling","leafers-sapling","leafers-tree","leafers-ultimate","piceratops-seed","piceratops-seedling","piceratops-sapling","piceratops-tree","piceratops-ultimate","duskpin-seed","duskpin-seedling","duskpin-sapling","duskpin-tree","duskpin-ultimate","primosaur-seed","primosaur-seedling","primosaur-sapling","primosaur-tree","primosaur-ultimate","starky-seed","starky-seedling","starky-sapling","starky-tree","starky-ultimate","aqualine-seed","aqualine-seedling","aqualine-sapling","aqualine-tree","aqualine-ultimate","spunky-sam","spunky-sam-green","spunky-sam-orange","spunky-sam-red","marcimus","marcimus-orange","marcimus-red","marcimus-purple","mr-pink","mr-pink-green","mr-pink-orange","robot_female_1","robot_female_2","robot_female_3","robot_male_1","robot_male_2","robot_male_3","orange-juice-squid","purple-pi","purple-pi-pink","purple-pi-teal","mr-pants","mr-pants-green","mr-pants-orange","mr-pants-pink","mr-pants-purple","old-spice-man","old-spice-man-blue","cs-winston","cs-winston-baby","cs-ohnoes","cs-hopper-happy","cs-hopper-jumping","cs-hopper-cool"];function Qt(t){return Vr[Mr.indexOf(t)]}function $t(t){return Mr[Vr.indexOf(t)]}function cr(t){return`https://www.khanacademy.org/images/avatars/svg/${t}.svg`}function ur(t){return`https://www.khanacademy.org/images/avatars/${t}.png`}function Le(t){return t.match(/^(?:https:\/\/www\.khanacademy\.org)?\/images\/avatars(?:\/svg)?\/(.*)\.(?:(?:svg)|(?:png))$/)?.[1]??null}function Gt(t){let r=Le(t);return r?ur(r):null}function Ht(t){let r=Le(t);return r?cr(r):null}function ct(t){return t.replace(/[a-zA-Z]+, \d\d [A-Za-z0-9]+ \d{4} \d\d:\d\d:\d\d [a-zA-Z]+/g,"").replace(/; (Path|Expires|Max-Age|HttpOnly|Secure|SameSite)[^;,]*/g,"").replace(/,/g,";")}var W=class extends H{get bySelf(){return this.client?.user?this.byUser(this.client.user):!1}get url(){if(!this.program?.url||!this.encryptedKey)return null;let r={qa_expand_key:this.key??this.encryptedKey,qa_expand_type:this.rawData?.feedbackType?.toLowerCase()},e=new URL(this.program.url);for(let[a,s]of Object.entries(r))s&&e.searchParams.set(a,s);return e.toString()}transformSchema(r){return{text:r.content,author:r.author&&V.fromSchema(r.author),program:(()=>{if(r.focus?.kind==="Scratchpad")return new C({id:typeof r.focus.id=="string"?parseInt(r.focus.id,10):void 0,title:r.focus.translatedTitle});if(r.focusUrl){let e=r.focusUrl.match(_r);return!e||e.length<1?void 0:new C({id:parseInt(e[1],10)})}})(),created:r.date?new Date(r.date):void 0,key:r.expandKey,encryptedKey:r.key,deleted:r.appearsAsDeleted,locked:r.isLocked,pinned:r.isPinned,verified:r.definitelyNotSpam,score:r.lowQualityScore,byVideoAuthor:r.fromVideoAuthor,selfFlagged:r.flaggedByUser}}byUser(r){return this.author?this.author.is(r):!1}is(r){return!(this.key&&r.key)&&!(this.encryptedKey&&r.encryptedKey)?(console.warn("Messages don't have any identifiers that can be compared"),!1):this.key&&r.key&&this.key===r.key||this.encryptedKey&&r.encryptedKey&&this.encryptedKey===r.encryptedKey||!1}};var le=(a=>(a[a.TipsAndThanks="COMMENT"]="TipsAndThanks",a[a.Question="QUESTION"]="Question",a[a.HelpRequest="PROJECT_HELP_QUESTION"]="HelpRequest",a))(le||{}),Oe,Br,qe=class qe extends W{constructor(){super(...arguments);U(this,Oe)}get selfVoted(){return this.client?.authenticated===!1?null:this.selfUpvoted?1:this.selfDownvoted?-1:0}static fromSchema(e){let a=new qe;return a.copyFromSchema(e),a.rawData=e,a}static fromIdentifier(e){return new qe({key:I(e)?e:void 0,encryptedKey:v(e)?e:void 0})}transformSchema(e){return{...super.transformSchema(e),votes:e.sumVotesIncremented,replyCount:e.replyCount,selfUpvoted:e.upVoted,selfDownvoted:e.downVoted}}copy(e){return super.copy(e)}async get(e=this.client??new g){let a=await e.getMessage(m(this,Oe,Br).call(this));return this.copy(a)}async*getReplies(e=this.client??new g,a){for await(let s of e.getMessageReplies(m(this,Oe,Br).call(this),a))this.replies||this.copy({replies:[]}),this.replies?.push(...s),yield s;return this}async getAllReplies(e=this.client??new g){if(!this.key&&!this.encryptedKey)throw new Error("Message does not have a key or encrypted key");let a=await e.getAllMessageReplies(this.key??this.encryptedKey);return this.copy({replies:a})}};Oe=new WeakSet,Br=function(){if(this.key)return this.key;if(this.encryptedKey)return this.encryptedKey;throw new Error("Message does not have a key or encrypted key")},qe.Type=le;var R=qe;var de=class t extends R{static fromSchema(r){let e=new t;return e.copyFromSchema(r),e.rawData=r,e}static fromIdentifier(r){return new t({key:I(r)?r:void 0,encryptedKey:v(r)?r:void 0})}transformSchema(r){return{...super.transformSchema(r),question:r.question?L.fromSchema(r.question):void 0}}copy(r){return super.copy(r)}};var L=class t extends R{static fromSchema(r){let e=new t;return e.copyFromSchema(r),e.rawData=r,e}static fromIdentifier(r){return new t({key:I(r)?r:void 0,encryptedKey:v(r)?r:void 0})}transformSchema(r){return{...super.transformSchema(r),answerCount:r.answerCount,old:r.isOld,answers:(()=>{if(!r.answers)return;let e=r.answers.map(a=>de.fromSchema(a));return e.forEach(a=>a.copy({question:this})),e})()}}copy(r){return super.copy(r)}};var Y=class t extends W{static fromSchema(r){let e=new t;return e.copyFromSchema(r),e.rawData=r,e}static fromIdentifier(r){return new t({key:I(r)?r:void 0,encryptedKey:v(r)?r:void 0})}transformSchema(r){return{...super.transformSchema(r),message:(()=>{if(!(typeof r.replyExpandKeys>"u")){if(typeof r.replyExpandKeys=="string"&&I(r.replyExpandKeys))return new R({key:r.replyExpandKeys});if(Array.isArray(r.replyExpandKeys))return new R({key:r.replyExpandKeys[0]})}})()}}copy(r){return super.copy(r)}copyFromSchema(r){return super.copyFromSchema(r)}async get(r=this.client??new g){if(!this.key&&!this.encryptedKey)throw new Error("Message does not have a key or encrypted key");let e=await r.getMessage(this.key??this.encryptedKey);return this.copy(e)}};var J=class t extends R{static fromSchema(r){let e=new t;return e.copyFromSchema(r),e.rawData=r,e}static fromIdentifier(r){return new t({key:I(r)?r:void 0,encryptedKey:v(r)?r:void 0})}transformSchema(r){return{...super.transformSchema(r),votes:r.sumVotesIncremented,replyCount:r.replyCount,selfUpvoted:r.upVoted,selfDownvoted:r.downVoted}}copy(r){return super.copy(r)}};function Nr(t){return t.feedbackType==="COMMENT"}function jt(t){return t.feedbackType==="REPLY"}function Qr(t){return t.feedbackType==="QUESTION"||t.feedbackType==="PROJECT_HELP_QUESTION"}function Wt(t){return t.feedbackType==="ANSWER"}var $r={[le.TipsAndThanks]:J,[le.Question]:L,[le.HelpRequest]:L};var z,pe,ce,$,be,ke,T,D,E=class E{constructor(){U(this,z);U(this,pe);U(this,ce);U(this,$,new Map);U(this,be,new Map);U(this,ke,new Map);this.authenticated=!1;this.kaid=null;return this}async resolveCachedKaid(r){if(P(r))return r;if(b(this,$).has(r))return b(this,$).get(r);let e=await pr(r);return b(this,$).set(r,e),e}async resolveCachedUsername(r){if(!P(r)&&!K(r)&&!ae(r))return r;if(b(this,be).has(r))return b(this,be).get(r);let e=await Lr(r);return b(this,be).set(r,e),e}async resolveCachedFeedbackKey(r){if(I(r))return r;if(b(this,ke).has(r))return b(this,ke).get(r);let e=await qr(r);return b(this,ke).set(r,e),e}get kaas(){return!this.authenticated||!b(this,ce)?null:b(this,ce).match(/KAAS=([^;]+)/)?.[1]??null}async login(r,e){var l;if(r&&(P(r)&&(r=await this.resolveCachedUsername(r)),Ne(this,z,r)),e&&Ne(this,pe,e),!b(this,z)||!b(this,pe))throw b(this,z)?b(this,pe)?new Error("Missing username/email and password"):new Error("Missing password"):new Error("Missing username or email");let a=await Fe({identifier:b(this,z),password:b(this,pe)},{credentials:"include"}),s=await m(l=E,T,D).call(l,a);if(A(s),!s.data.loginWithPassword)throw new Error("Malformed response");if(s.data.loginWithPassword.error)switch(s.data.loginWithPassword.error.code){case ne.ErrorCode.INVALID_CREDENTIALS:throw new Error("Invalid Credentials error: Check your username/email and password");case ne.ErrorCode.TOO_MANY_ATTEMPTS:throw new Error("Too Many Attempts error: Rate-limited by Khan Academy");default:throw new Error("Unknown error code: "+s.data.loginWithPassword.error.code)}let n=a.headers.get("set-cookie");if(!n)throw new Error("No cookies returned: Something went wrong on Khan Academy's end");return Ne(this,ce,ct(n)),this.authenticated=!0,this.kaid=typeof s.data.loginWithPassword.user?.kaid=="string"&&P(s.data.loginWithPassword.user.kaid)?s.data.loginWithPassword.user.kaid:null,this.kaid===null&&console.warn(`User ${r??this.kaas??"unknown"} does not have a valid KAID`),this}async getUser(r){var l;if(!r&&!this.authenticated)throw new Error("Not authenticated: You need to login or provide an indentifier");let e=null;r&&(K(r)&&(e=r),r=await this.resolveCachedKaid(r));let a=await Ae(r,r?void 0:{credentials:"include",headers:{cookie:b(this,ce)}}),s=await m(l=E,T,D).call(l,a);if(A(s),!s.data.user)throw new Error("User not found");let n=V.fromSchema(s.data.user);return n.client=this,!n.email&&e&&K(e)&&n.copy({email:e}),n.self&&(this.user=n),n.kaid&&(n.username&&!b(this,$).has(n.username)&&b(this,$).set(n.username,n.kaid),n.email&&!b(this,$).has(n.email)&&b(this,$).set(n.email,n.kaid)),n}async getUserAvatar(r=this.kaid??b(this,z),e="svg"){var l;if(!r)throw new Error("No identifier provided");r=await this.resolveCachedKaid(r);let a=await _e(r),s=await m(l=E,T,D).call(l,a);if(A(s),!s.data.user)throw new Error("User not found");let n=Le(s.data.user.avatar.imageSrc);if(!n)throw new Error("User has no avatar");return e==="svg"?cr(n):ur(n)}async getUserStatistics(r=this.kaid??b(this,z)){var s;if(!r)throw new Error("No identifier provided");r=await this.resolveCachedKaid(r);let e=await Ie(r),a=await m(s=E,T,D).call(s,e);if(A(a),!a.data.user)throw new Error("User not found");return{votes:a.data.userSummary.statistics.votes,tipsAndThanks:a.data.userSummary.statistics.comments,questions:a.data.userSummary.statistics.questions,answers:a.data.userSummary.statistics.answers,helpRequests:a.data.userSummary.statistics.projectquestions,helpRequestAnswers:a.data.userSummary.statistics.projectanswers,replies:a.data.userSummary.statistics.replies,flags:a.data.userSummary.statistics.flags}}async*getUserPrograms(r,e="TOP",a=40){if(!r&&!this.authenticated)throw new Error("Not authenticated: You need to login or provide an indentifier");if(r??(r=this.kaid??this.user?.username??this.user?.email),!r)throw new Error("Missing identifier for logged in user");let n={kaid:await this.resolveCachedKaid(r),pageInfo:{cursor:null,itemsPerPage:a},sort:e},l=async x=>{var y;let w=await Ke({...n,pageInfo:{...n.pageInfo,cursor:x}}),c=await m(y=E,T,D).call(y,w);if(A(c),!c.data.user)throw new Error("User not found");if(!c.data.user.programs.complete&&!c.data.user.programs.cursor)throw new Error("Cursor not found");let q=c.data.user.programs.programs.map(G=>{let we=C.fromSchema(G);return we.client=this,we}),O=c.data.user.programs.complete?null:c.data.user.programs.cursor;return{programs:q,cursor:O}},{programs:p,cursor:k}=await l();for(yield p;k;)({programs:p,cursor:k}=await l(k)),yield p}async getAllUserPrograms(r,e="TOP",a=100){let s=[];for await(let n of this.getUserPrograms(r,e,a))s.push(...n);return s}async getProgram(r){var n;r=he(r);let e=await ve(r),a=await m(n=E,T,D).call(n,e);if(A(a),!a.data.programById)throw new Error("Program not found");let s=C.fromSchema(a.data.programById);return s.client=this,this.user&&s.author?.kaid===this.kaid&&(s.copy({author:this.user}),console.debug(`Copied the client's user data to program ${s.title?`"${et(s.title,32)}"`:s.id??"unknown"} because the program's author matches the client user`)),s}async*getHotlistPrograms(r="HOT",e=40,a=!1){let s={onlyOfficialProjectSpinoffs:a,sort:r,pageInfo:{cursor:null,itemsPerPage:e}},n=async k=>{var O;let x=await Ue({...s,pageInfo:{...s.pageInfo,cursor:k}}),w=await m(O=E,T,D).call(O,x);if(A(w),!w.data.listTopPrograms)throw new Error("Programs not found");if(!w.data.listTopPrograms.complete&&!w.data.listTopPrograms.cursor)throw new Error("Cursor not found");let B=w.data.listTopPrograms.programs.map(y=>{let G=C.fromSchema(y);return G.client=this,G}),q=w.data.listTopPrograms.complete?null:w.data.listTopPrograms.cursor;return{programs:B,cursor:q}},{programs:l,cursor:p}=await n();for(yield l;p;)({programs:l,cursor:p}=await n(p)),yield l}async*getTopPrograms(r=40,e=!1){yield*this.getHotlistPrograms("TOP",r,e)}async*getRecentPrograms(r=40,e=!1){yield*this.getHotlistPrograms("RECENT",r,e)}async getMessage(r){var l;I(r)||(r=await this.resolveCachedFeedbackKey(r));let e=await me({topicId:Yr.toString(),focusKind:"Scratchpad",feedbackType:"COMMENT",currentSort:1,qaExpandKey:r}),a=await m(l=E,T,D).call(l,e);if(A(a),!a.data.feedback||!a.data.feedback.feedback||a.data.feedback.feedback.length===0)throw new Error("Message not found");let s=a.data.feedback.feedback[0],n;if(Nr(s))n=J.fromSchema(s);else if(Qr(s)){let p=L.fromSchema(s);if(p.key!==r){let k=p.answers?.find(x=>x.key===r);if(!k)throw new Error("Question or answer not found");n=k,n.copy({question:p})}else n=p}else throw new Error("Unknown message type");return n.client=this,this.user&&n.author?.kaid===this.kaid&&(n.copy({author:this.user}),console.debug(`Copied the client's user data to comment ${n.key??n.encryptedKey??"unknown"} because the comment's author matches the client user`)),n}async getTipsAndThanks(r){return this.getMessage(r)}async getQuestion(r){return this.getMessage(r)}async getAnswer(r){return this.getMessage(r)}async getReply(r){var p;let e=await this.getMessage(r);if(!e.key)throw new Error("Message has no key");let a=await ye(e.key),s=await m(p=E,T,D).call(p,a);if(A(s),!s.data.feedbackReplies||s.data.feedbackReplies.length===0)throw new Error("Reply not found");let n=s.data.feedbackReplies.find(k=>k.expandKey===r||k.key===r);if(!n)throw new Error("Reply not found");let l=Y.fromSchema(n);return l.client=this,l.copy({message:e}),this.user&&l.author?.kaid===this.kaid&&(l.copy({author:this.user}),console.debug(`Copied the client's user data to reply ${l.key??l.encryptedKey??"unknown"} because the reply's author matches the client user`)),l}async*getProgramMessages(r=R.Type.TipsAndThanks,e,a=1){e=he(e);let s={topicId:e.toString(),focusKind:"Scratchpad",feedbackType:r,currentSort:a},n=async k=>{var O;let x=await me({...s,cursor:k}),w=await m(O=E,T,D).call(O,x);if(A(w),!w.data.feedback.feedback)throw new Error("Comments not found");if(!w.data.feedback.isComplete&&!w.data.feedback.cursor)throw new Error("Cursor not found");let B=w.data.feedback.feedback.map(y=>{let G=$r[r].fromSchema(y);return G.client=this,G}),q=!w.data.feedback.isComplete&&w.data.feedback.cursor;return{messages:B,cursor:q}},{messages:l,cursor:p}=await n();for(yield l;p;)({messages:l,cursor:p}=await n(p)),yield l}async getAllProgramMessages(r=R.Type.TipsAndThanks,e,a=1){let s=[];for await(let n of this.getProgramMessages(r,e,a))s.push(...n);return s}async*getProgramTipsAndThanks(r,e=1){yield*this.getProgramMessages(R.Type.TipsAndThanks,r,e)}async getAllProgramTipsAndThanks(r,e=1){return this.getAllProgramMessages(R.Type.TipsAndThanks,r,e)}async*getProgramQuestions(r,e=1){yield*this.getProgramMessages(R.Type.Question,r,e)}async getAllProgramQuestions(r,e=1){return this.getAllProgramMessages(R.Type.Question,r,e)}async*getProgramHelpRequests(r,e=1){yield*this.getProgramMessages(R.Type.HelpRequest,r,e)}async getAllProgramHelpRequests(r,e=1){return this.getAllProgramMessages(R.Type.HelpRequest,r,e)}async*getMessageReplies(r,e=10){let a={postKey:r,cursor:null,limit:e},s=async p=>{var q;let k=await Pe({...a,cursor:p}),x=await m(q=E,T,D).call(q,k);if(A(x),!x.data.feedbackRepliesPaginated)throw new Error("Replies not found");if(!x.data.feedbackRepliesPaginated.isComplete&&!x.data.feedbackRepliesPaginated.cursor)throw new Error("Cursor not found");let w=x.data.feedbackRepliesPaginated.feedback;if(!w)return{replies:[],cursor:null};let c=w.map(O=>{let y=Y.fromSchema(O);return y.client=this,y}),B=x.data.feedbackRepliesPaginated.isComplete?null:x.data.feedbackRepliesPaginated.cursor;return{replies:c,cursor:B}},{replies:n,cursor:l}=await s();for(yield n;l;)({replies:n,cursor:l}=await s(l)),yield n}async getAllMessageReplies(r){var n;let e=await ye(r),a=await m(n=E,T,D).call(n,e);if(A(a),!a.data.feedbackReplies)throw new Error("Replies not found");return a.data.feedbackReplies.map(l=>{let p=Y.fromSchema(l);return p.client=this,p})}};z=new WeakMap,pe=new WeakMap,ce=new WeakMap,$=new WeakMap,be=new WeakMap,ke=new WeakMap,T=new WeakSet,D=async function(r){try{return await r.json()}catch(e){let a=e instanceof Error?e.message:typeof e=="string"?e:"Unknown error";throw new Error(`Failed to parse response JSON: ${a}`)}},U(E,T);var g=E;var ut=(l=>(l[l.Meteorite=0]="Meteorite",l[l.Moon=1]="Moon",l[l.Earth=2]="Earth",l[l.Sun=3]="Sun",l[l.BlackHole=4]="BlackHole",l[l.Challenge=5]="Challenge",l))(ut||{});return At(Yt);})();
//# sourceMappingURL=khan-api.min.js.map
