/**
 * Khan API v0.7.2
 * https://khan-api.bhavjit.com
 * Licensed under MIT license
 * Copyright 2024 Bhavjit Chauhan
 */

var it=Object.create;var nr=Object.defineProperty;var lt=Object.getOwnPropertyDescriptor;var dt=Object.getOwnPropertyNames;var pt=Object.getPrototypeOf,ct=Object.prototype.hasOwnProperty;var br=t=>{throw TypeError(t)};var ut=(t,r)=>()=>(r||t((r={exports:{}}).exports,r),r.exports),kr=(t,r)=>{for(var e in r)nr(t,e,{get:r[e],enumerable:!0})},mt=(t,r,e,a)=>{if(r&&typeof r=="object"||typeof r=="function")for(let s of dt(r))!ct.call(t,s)&&s!==e&&nr(t,s,{get:()=>r[s],enumerable:!(a=lt(r,s))||a.enumerable});return t};var yt=(t,r,e)=>(e=t!=null?it(pt(t)):{},mt(r||!t||!t.__esModule?nr(e,"default",{value:t,enumerable:!0}):e,t));var ir=(t,r,e)=>r.has(t)||br("Cannot "+e);var b=(t,r,e)=>(ir(t,r,"read from private field"),e?e.call(t):r.get(t)),U=(t,r,e)=>r.has(t)?br("Cannot add the same private member more than once"):r instanceof WeakSet?r.add(t):r.set(t,e),Le=(t,r,e,a)=>(ir(t,r,"write to private field"),a?a.call(t,e):r.set(t,e),e),m=(t,r,e)=>(ir(t,r,"access private method"),e);var Rr=ut((J,Pr)=>{var Oe=typeof globalThis<"u"&&globalThis||typeof self<"u"&&self||typeof global<"u"&&global,Me=function(){function t(){this.fetch=!1,this.DOMException=Oe.DOMException}return t.prototype=Oe,new t}();(function(t){var r=function(e){var a=typeof t<"u"&&t||typeof self<"u"&&self||typeof a<"u"&&a,s={searchParams:"URLSearchParams"in a,iterable:"Symbol"in a&&"iterator"in Symbol,blob:"FileReader"in a&&"Blob"in a&&function(){try{return new Blob,!0}catch{return!1}}(),formData:"FormData"in a,arrayBuffer:"ArrayBuffer"in a};function n(o){return o&&DataView.prototype.isPrototypeOf(o)}if(s.arrayBuffer)var l=["[object Int8Array]","[object Uint8Array]","[object Uint8ClampedArray]","[object Int16Array]","[object Uint16Array]","[object Int32Array]","[object Uint32Array]","[object Float32Array]","[object Float64Array]"],p=ArrayBuffer.isView||function(o){return o&&l.indexOf(Object.prototype.toString.call(o))>-1};function k(o){if(typeof o!="string"&&(o=String(o)),/[^a-z0-9\-#$%&'*+.^_`|~!]/i.test(o)||o==="")throw new TypeError('Invalid character in header field name: "'+o+'"');return o.toLowerCase()}function x(o){return typeof o!="string"&&(o=String(o)),o}function w(o){var i={next:function(){var d=o.shift();return{done:d===void 0,value:d}}};return s.iterable&&(i[Symbol.iterator]=function(){return i}),i}function c(o){this.map={},o instanceof c?o.forEach(function(i,d){this.append(d,i)},this):Array.isArray(o)?o.forEach(function(i){this.append(i[0],i[1])},this):o&&Object.getOwnPropertyNames(o).forEach(function(i){this.append(i,o[i])},this)}c.prototype.append=function(o,i){o=k(o),i=x(i);var d=this.map[o];this.map[o]=d?d+", "+i:i},c.prototype.delete=function(o){delete this.map[k(o)]},c.prototype.get=function(o){return o=k(o),this.has(o)?this.map[o]:null},c.prototype.has=function(o){return this.map.hasOwnProperty(k(o))},c.prototype.set=function(o,i){this.map[k(o)]=x(i)},c.prototype.forEach=function(o,i){for(var d in this.map)this.map.hasOwnProperty(d)&&o.call(i,this.map[d],d,this)},c.prototype.keys=function(){var o=[];return this.forEach(function(i,d){o.push(d)}),w(o)},c.prototype.values=function(){var o=[];return this.forEach(function(i){o.push(i)}),w(o)},c.prototype.entries=function(){var o=[];return this.forEach(function(i,d){o.push([d,i])}),w(o)},s.iterable&&(c.prototype[Symbol.iterator]=c.prototype.entries);function V(o){if(o.bodyUsed)return Promise.reject(new TypeError("Already read"));o.bodyUsed=!0}function C(o){return new Promise(function(i,d){o.onload=function(){i(o.result)},o.onerror=function(){d(o.error)}})}function L(o){var i=new FileReader,d=C(i);return i.readAsArrayBuffer(o),d}function y(o){var i=new FileReader,d=C(i);return i.readAsText(o),d}function G(o){for(var i=new Uint8Array(o),d=new Array(i.length),_=0;_<i.length;_++)d[_]=String.fromCharCode(i[_]);return d.join("")}function be(o){if(o.slice)return o.slice(0);var i=new Uint8Array(o.byteLength);return i.set(new Uint8Array(o)),i.buffer}function hr(){return this.bodyUsed=!1,this._initBody=function(o){this.bodyUsed=this.bodyUsed,this._bodyInit=o,o?typeof o=="string"?this._bodyText=o:s.blob&&Blob.prototype.isPrototypeOf(o)?this._bodyBlob=o:s.formData&&FormData.prototype.isPrototypeOf(o)?this._bodyFormData=o:s.searchParams&&URLSearchParams.prototype.isPrototypeOf(o)?this._bodyText=o.toString():s.arrayBuffer&&s.blob&&n(o)?(this._bodyArrayBuffer=be(o.buffer),this._bodyInit=new Blob([this._bodyArrayBuffer])):s.arrayBuffer&&(ArrayBuffer.prototype.isPrototypeOf(o)||p(o))?this._bodyArrayBuffer=be(o):this._bodyText=o=Object.prototype.toString.call(o):this._bodyText="",this.headers.get("content-type")||(typeof o=="string"?this.headers.set("content-type","text/plain;charset=UTF-8"):this._bodyBlob&&this._bodyBlob.type?this.headers.set("content-type",this._bodyBlob.type):s.searchParams&&URLSearchParams.prototype.isPrototypeOf(o)&&this.headers.set("content-type","application/x-www-form-urlencoded;charset=UTF-8"))},s.blob&&(this.blob=function(){var o=V(this);if(o)return o;if(this._bodyBlob)return Promise.resolve(this._bodyBlob);if(this._bodyArrayBuffer)return Promise.resolve(new Blob([this._bodyArrayBuffer]));if(this._bodyFormData)throw new Error("could not read FormData body as blob");return Promise.resolve(new Blob([this._bodyText]))},this.arrayBuffer=function(){if(this._bodyArrayBuffer){var o=V(this);return o||(ArrayBuffer.isView(this._bodyArrayBuffer)?Promise.resolve(this._bodyArrayBuffer.buffer.slice(this._bodyArrayBuffer.byteOffset,this._bodyArrayBuffer.byteOffset+this._bodyArrayBuffer.byteLength)):Promise.resolve(this._bodyArrayBuffer))}else return this.blob().then(L)}),this.text=function(){var o=V(this);if(o)return o;if(this._bodyBlob)return y(this._bodyBlob);if(this._bodyArrayBuffer)return Promise.resolve(G(this._bodyArrayBuffer));if(this._bodyFormData)throw new Error("could not read FormData body as text");return Promise.resolve(this._bodyText)},s.formData&&(this.formData=function(){return this.text().then(at)}),this.json=function(){return this.text().then(JSON.parse)},this}var rt=["DELETE","GET","HEAD","OPTIONS","POST","PUT"];function tt(o){var i=o.toUpperCase();return rt.indexOf(i)>-1?i:o}function Y(o,i){if(!(this instanceof Y))throw new TypeError('Please use the "new" operator, this DOM object constructor cannot be called as a function.');i=i||{};var d=i.body;if(o instanceof Y){if(o.bodyUsed)throw new TypeError("Already read");this.url=o.url,this.credentials=o.credentials,i.headers||(this.headers=new c(o.headers)),this.method=o.method,this.mode=o.mode,this.signal=o.signal,!d&&o._bodyInit!=null&&(d=o._bodyInit,o.bodyUsed=!0)}else this.url=String(o);if(this.credentials=i.credentials||this.credentials||"same-origin",(i.headers||!this.headers)&&(this.headers=new c(i.headers)),this.method=tt(i.method||this.method||"GET"),this.mode=i.mode||this.mode||null,this.signal=i.signal||this.signal,this.referrer=null,(this.method==="GET"||this.method==="HEAD")&&d)throw new TypeError("Body not allowed for GET or HEAD requests");if(this._initBody(d),(this.method==="GET"||this.method==="HEAD")&&(i.cache==="no-store"||i.cache==="no-cache")){var _=/([?&])_=[^&]*/;if(_.test(this.url))this.url=this.url.replace(_,"$1_="+new Date().getTime());else{var S=/\?/;this.url+=(S.test(this.url)?"&":"?")+"_="+new Date().getTime()}}}Y.prototype.clone=function(){return new Y(this,{body:this._bodyInit})};function at(o){var i=new FormData;return o.trim().split("&").forEach(function(d){if(d){var _=d.split("="),S=_.shift().replace(/\+/g," "),u=_.join("=").replace(/\+/g," ");i.append(decodeURIComponent(S),decodeURIComponent(u))}}),i}function ot(o){var i=new c,d=o.replace(/\r?\n[\t ]+/g," ");return d.split("\r").map(function(_){return _.indexOf(`
`)===0?_.substr(1,_.length):_}).forEach(function(_){var S=_.split(":"),u=S.shift().trim();if(u){var Fe=S.join(":").trim();i.append(u,Fe)}}),i}hr.call(Y.prototype);function q(o,i){if(!(this instanceof q))throw new TypeError('Please use the "new" operator, this DOM object constructor cannot be called as a function.');i||(i={}),this.type="default",this.status=i.status===void 0?200:i.status,this.ok=this.status>=200&&this.status<300,this.statusText=i.statusText===void 0?"":""+i.statusText,this.headers=new c(i.headers),this.url=i.url||"",this._initBody(o)}hr.call(q.prototype),q.prototype.clone=function(){return new q(this._bodyInit,{status:this.status,statusText:this.statusText,headers:new c(this.headers),url:this.url})},q.error=function(){var o=new q(null,{status:0,statusText:""});return o.type="error",o};var st=[301,302,303,307,308];q.redirect=function(o,i){if(st.indexOf(i)===-1)throw new RangeError("Invalid status code");return new q(null,{status:i,headers:{location:o}})},e.DOMException=a.DOMException;try{new e.DOMException}catch{e.DOMException=function(i,d){this.message=i,this.name=d;var _=Error(i);this.stack=_.stack},e.DOMException.prototype=Object.create(Error.prototype),e.DOMException.prototype.constructor=e.DOMException}function sr(o,i){return new Promise(function(d,_){var S=new Y(o,i);if(S.signal&&S.signal.aborted)return _(new e.DOMException("Aborted","AbortError"));var u=new XMLHttpRequest;function Fe(){u.abort()}u.onload=function(){var K={status:u.status,statusText:u.statusText,headers:ot(u.getAllResponseHeaders()||"")};K.url="responseURL"in u?u.responseURL:K.headers.get("X-Request-URL");var Ce="response"in u?u.response:u.responseText;setTimeout(function(){d(new q(Ce,K))},0)},u.onerror=function(){setTimeout(function(){_(new TypeError("Network request failed"))},0)},u.ontimeout=function(){setTimeout(function(){_(new TypeError("Network request failed"))},0)},u.onabort=function(){setTimeout(function(){_(new e.DOMException("Aborted","AbortError"))},0)};function nt(K){try{return K===""&&a.location.href?a.location.href:K}catch{return K}}u.open(S.method,nt(S.url),!0),S.credentials==="include"?u.withCredentials=!0:S.credentials==="omit"&&(u.withCredentials=!1),"responseType"in u&&(s.blob?u.responseType="blob":s.arrayBuffer&&S.headers.get("Content-Type")&&S.headers.get("Content-Type").indexOf("application/octet-stream")!==-1&&(u.responseType="arraybuffer")),i&&typeof i.headers=="object"&&!(i.headers instanceof c)?Object.getOwnPropertyNames(i.headers).forEach(function(K){u.setRequestHeader(K,x(i.headers[K]))}):S.headers.forEach(function(K,Ce){u.setRequestHeader(Ce,K)}),S.signal&&(S.signal.addEventListener("abort",Fe),u.onreadystatechange=function(){u.readyState===4&&S.signal.removeEventListener("abort",Fe)}),u.send(typeof S._bodyInit>"u"?null:S._bodyInit)})}return sr.polyfill=!0,a.fetch||(a.fetch=sr,a.Headers=c,a.Request=Y,a.Response=q),e.Headers=c,e.Request=Y,e.Response=q,e.fetch=sr,e}({})})(Me);Me.fetch.ponyfill=!0;delete Me.fetch.polyfill;var ne=Oe.fetch?Oe:Me;J=ne.fetch;J.default=ne.fetch;J.fetch=ne.fetch;J.Headers=ne.Headers;J.Request=ne.Request;J.Response=ne.Response;Pr.exports=J});var Vr={};kr(Vr,{AvatarDataForProfile:()=>Ve,FeedbackQuery:()=>Be,GetFeedbackReplies:()=>Ne,GetFeedbackRepliesPage:()=>Qe,GetFullUserProfile:()=>We,GetProfileWidgets:()=>Ye,GetUserByUsernameOrEmail:()=>Je,GetUserHoverCardProfile:()=>ze,Hotlist:()=>Ze,ProgramQuery:()=>Xe,ProjectsAuthoredByUser:()=>er,QAExpandKeyInfo:()=>Te,QaExpandKeyInfo:()=>rr,avatarDataForProfile:()=>ke,feedbackQuery:()=>le,getFeedbackReplies:()=>de,getFeedbackRepliesPage:()=>we,getFullUserProfile:()=>Pe,getProfileWidgets:()=>Re,getUserByUsernameOrEmail:()=>Se,getUserHoverCardProfile:()=>xe,hotlist:()=>Ae,programQuery:()=>Ie,projectsAuthoredByUser:()=>Ee});var f="https://www.khanacademy.org/api/internal/graphql",qe="https://cdn.jsdelivr.net/gh/bhavjitChauhan/khan-api@safelist",wr="khan-proxy.bhavjit.com",lr=`bhavjitchauhan/khan-api_${Date.now()}`,_r=4669512406581248;var Ar=yt(Rr(),1);async function dr(t){let r=await ie(`${qe}/query/${t}`);return r.status===404?null:await r.text()}async function Sr(t){let r=await ie(`${qe}/mutation/${t}`);return r.status===404?null:await r.text()}async function Ut(t){let r=await ie(`${qe}/fragment/${t}`);return r.status===404?null:await r.text()}function ft(t){let r=5381,e=t.length;for(;e;)r=r*33^t.charCodeAt(--e);return r>>>0}async function vt(t){let r=await dr(t);return r?ft(r):null}async function ie(t,r){return await(0,Ar.default)(t,r)}async function Ct(t,r){return r={method:"get",...r},await ie(t,r)}async function xr(t,r,e){return e={method:"post",body:JSON.stringify(r),...e},await ie(t,e)}async function g(t,r,e={},a){let s={query:r,variables:e};typeof window<"u"&&window.location.hostname!=="khanacademy.org"&&(t=t.replace("www.khanacademy.org",wr));let n=await xr(t,s,a);if(n.status===403){let l=r.startsWith("query"),p=r.match(/^(?:query|mutation) (\w+)/)?.[1];if(!p)throw new Error("An unknown query is no longer in the safelist");console.warn(`The query for operation "${p}" is no longer in the safelist. Attempting to fetch the latest version from the safelist...`);let k=l?await dr(p):await Sr(p);if(!k)throw new Error(`The query for operation "${p}" was not found in the safelist`);return await xr(t,{...s,query:k},a)}return n}var Ve;(r=>r.query=`query avatarDataForProfile($kaid: String!) {
  user(kaid: $kaid) {
    id
    avatar {
      name
      imageSrc
      __typename
    }
    __typename
  }
}`)(Ve||(Ve={}));function ke(t,r){return g(`${f}/avatarDataForProfile`,Ve.query,typeof t=="string"?{kaid:t}:t,r)}var Be;(r=>r.query=`query feedbackQuery($topicId: String!, $focusKind: String!, $cursor: String, $limit: Int, $feedbackType: FeedbackType!, $currentSort: Int, $qaExpandKey: String) {
  feedback(
    focusId: $topicId
    cursor: $cursor
    limit: $limit
    feedbackType: $feedbackType
    focusKind: $focusKind
    sort: $currentSort
    qaExpandKey: $qaExpandKey
    answersLimit: 1
  ) {
    feedback {
      isLocked
      isPinned
      replyCount
      appearsAsDeleted
      author {
        id
        kaid
        nickname
        avatar {
          name
          imageSrc
          __typename
        }
        __typename
      }
      badges {
        name
        icons {
          smallUrl
          __typename
        }
        description
        __typename
      }
      content
      date
      definitelyNotSpam
      deleted
      downVoted
      expandKey
      feedbackType
      flaggedBy
      flaggedByUser
      flags
      focusUrl
      focus {
        kind
        id
        translatedTitle
        relativeUrl
        __typename
      }
      fromVideoAuthor
      key
      lowQualityScore
      notifyOnAnswer
      permalink
      qualityKind
      replyCount
      replyExpandKeys
      showLowQualityNotice
      sumVotesIncremented
      upVoted
      ... on QuestionFeedback {
        hasAnswered
        answers {
          isLocked
          isPinned
          replyCount
          appearsAsDeleted
          author {
            id
            kaid
            nickname
            avatar {
              name
              imageSrc
              __typename
            }
            __typename
          }
          badges {
            name
            icons {
              smallUrl
              __typename
            }
            description
            __typename
          }
          content
          date
          definitelyNotSpam
          deleted
          downVoted
          expandKey
          feedbackType
          flaggedBy
          flaggedByUser
          flags
          focusUrl
          focus {
            kind
            id
            translatedTitle
            relativeUrl
            __typename
          }
          fromVideoAuthor
          key
          lowQualityScore
          notifyOnAnswer
          permalink
          qualityKind
          replyCount
          replyExpandKeys
          showLowQualityNotice
          sumVotesIncremented
          upVoted
          __typename
        }
        isOld
        answerCount
        __typename
      }
      ... on AnswerFeedback {
        question {
          isLocked
          isPinned
          replyCount
          appearsAsDeleted
          author {
            id
            kaid
            nickname
            avatar {
              name
              imageSrc
              __typename
            }
            __typename
          }
          badges {
            name
            icons {
              smallUrl
              __typename
            }
            description
            __typename
          }
          content
          date
          definitelyNotSpam
          deleted
          downVoted
          expandKey
          feedbackType
          flaggedBy
          flaggedByUser
          flags
          focusUrl
          focus {
            kind
            id
            translatedTitle
            relativeUrl
            __typename
          }
          fromVideoAuthor
          key
          lowQualityScore
          notifyOnAnswer
          permalink
          qualityKind
          replyCount
          replyExpandKeys
          showLowQualityNotice
          sumVotesIncremented
          upVoted
          __typename
        }
        __typename
      }
      __typename
    }
    cursor
    isComplete
    sortedByDate
    __typename
  }
}`)(Be||(Be={}));function le(t,r){return g(`${f}/feedbackQuery`,Be.query,t,r)}var Ne;(r=>r.query=`query getFeedbackReplies($postKey: String!) {
  feedbackReplies(feedbackKey: $postKey) {
    isLocked
    isPinned
    expandKey
    appearsAsDeleted
    author {
      id
      kaid
      nickname
      avatar {
        name
        imageSrc
        __typename
      }
      __typename
    }
    content
    date
    definitelyNotSpam
    deleted
    downVoted
    expandKey
    feedbackType
    flaggedBy
    flaggedByUser
    flags
    focusUrl
    fromVideoAuthor
    key
    lowQualityScore
    notifyOnAnswer
    permalink
    qualityKind
    replyCount
    replyExpandKeys
    showLowQualityNotice
    sumVotesIncremented
    upVoted
    __typename
  }
}`)(Ne||(Ne={}));function de(t,r){return g(`${f}/getFeedbackReplies`,Ne.query,typeof t=="string"?{postKey:t}:t,r)}var Qe;(r=>r.query=`query getFeedbackRepliesPage($postKey: String!, $cursor: String, $limit: Int!) {
  feedbackRepliesPaginated(feedbackKey: $postKey, cursor: $cursor, limit: $limit) {
    cursor
    isComplete
    feedback {
      isLocked
      isPinned
      expandKey
      appearsAsDeleted
      author {
        id
        kaid
        nickname
        avatar {
          name
          imageSrc
          __typename
        }
        __typename
      }
      content
      date
      definitelyNotSpam
      deleted
      downVoted
      expandKey
      feedbackType
      flaggedBy
      flaggedByUser
      flags
      focusUrl
      fromVideoAuthor
      key
      lowQualityScore
      notifyOnAnswer
      permalink
      qualityKind
      replyCount
      replyExpandKeys
      showLowQualityNotice
      sumVotesIncremented
      upVoted
      __typename
    }
    __typename
  }
}`)(Qe||(Qe={}));function we(t,r){return g(`${f}/getFeedbackRepliesPage`,Qe.query,t,r)}function Ir(t,r,e="..."){return r=Math.max(0,r),t.length>r?t.slice(0,r-e.length)+e:t}function $e(t){return t.replace(/-/g,"+").replace(/_/g,"/")}function Er(t){return t.replace(/\+/g,"-").replace(/\//g,"_").replace(/=/g,"")}function B(t){return new RegExp(`(${t.source.slice(1,-1)})`)}var Tr=["com","org"],Ur=["as","az","cs","da","el","gu","hu","id","it","lt","ja","kk","kn","ky","lv","mn","mr","my","nl","pt-pt","ru","sv","ta","uz","bg","bn","de","en","es","fr","hi","hy","ka","km","ko","nb","pa","pl","pt","ro","sr","tr","vi","zh-hans","sgn-us"],pr=/^kaid_\d{20,25}$/,Xt=B(pr),P=t=>pr.test(t),_e=new RegExp(`^https?:\\/\\/(?:(?:www|${Ur.join("|")})\\.)?khanacademy\\.(?:${Tr.join("|")})\\/profile\\/((?!kaid_|kaid_\\D)\\w+|(?:${pr.toString().slice(2,-2)}))(?:\\/.*)?$`,"i"),ea=B(_e),pe=t=>_e.test(t),gt=[9,10,16],cr=new RegExp(`^[1-9](?:(?:${gt.map(t=>`\\d{${t-1}}`).join("|")}))$`),vr=new RegExp(`(?:^|\\D)(${cr.source.slice(1,-1)})(?:$|\\D)`);function re(t){return cr.test(t.toString())}var Kr=["computer-programming","cs","pixar","nasa","piab-sandbox","computer-science","hour-of-code","math","differential-equations","electrical-engineering","mcat","apchem-topic","chemistry","art-history-basics","biology"],ce=new RegExp(`^https?:\\/\\/(?:(?:www|${Ur.join("|")})\\.)?khanacademy\\.(?:${Tr.join("|")})\\/(?:${Kr.join("|")})\\/[\\w\\d-.~()'!*:@,;]+\\/(${cr.toString().slice(2,-2)})$`,"i"),ra=B(ce);function Dr(t){return ce.test(t)}var Ge=new RegExp(`^\\/(?:${Kr.join("|")})\\/[\\w\\d-.~()'!*:@,;]+\\/\\d+\\/(\\d+)\\.png$`),ta=B(Ge),ht=[51,54],Fr=/^ag5zfmtoYW4tYWNhZGVteXI(?:U|X)CxIKU2NyYXRjaHBhZB(?:i|j)(?=[\w-]*$)(?:.{7}w|.{9}C(?:g|w|A|Q)w)$/,aa=B(Fr);function ue(t){if(ht.includes(t.length)||!Fr.test(t))return!1;try{return atob($e(t)),!0}catch{return!1}}var oa=[106,107,108,110,111],Cr=/^ag5zfmtoYW4tYWNhZGVteX(?:I|J)(?:A|B|7|9|-|_)CxIIVXNlckRhdGEi(?:Gm|GG|G2|Hm|HG|HW)thaWRf(?:M|N|O)(?:\w{34}|\w{29,31}|\w{27})(?:LEghGZWVkYmFjaxiAg[I-P](?:O|P|W|X|2|3)|DAsSCEZlZWRiYWNrGICA|MCxIIRmVlZGJhY2sYgI(?:C|D)|wLEghGZWVkYmFjaxiAg|DAsSCEZlZWRiYWNrGICA)(?:[\w-]{5}|[\w-]{7,8})(?:M|DA|C(?:g|w|A|Q)w)$/,sa=B(Cr),I=t=>Cr.test(t),na=[301],Lr=/^kaencrypted_[a-z0-9]{32}_[a-z0-9]{256}$/,ia=B(Lr),D=t=>Lr.test(t),He=/^http:\/\/googleid\.khanacademy\.org\/(\d+)$/,la=B(He),qr=t=>He.test(t),je=/^_gae_bingo_random:(\w+-\w+-\w+)$/,da=B(je),Or=t=>je.test(t),Mr=/^[a-zA-Z0-9.!#$%&’*+/=?^_`{|}~-]+@[a-zA-Z0-9-]+(?:\.[a-zA-Z0-9-]+)*$/,pa=B(Mr),F=t=>Mr.test(t);var We;(r=>r.query=`query getFullUserProfile($kaid: String, $username: String) {
  user(kaid: $kaid, username: $username) {
    id
    kaid
    key
    userId
    email
    username
    profileRoot
    gaUserId
    isPhantom
    isDeveloper: hasPermission(name: "can_do_what_only_admins_can_do")
    isPublisher: hasPermission(name: "can_publish", scope: ANY_ON_CURRENT_LOCALE)
    isModerator: hasPermission(name: "can_moderate_users", scope: GLOBAL)
    isParent
    isTeacher
    isFormalTeacher
    isK4dStudent
    isKmapStudent
    isDataCollectible
    isChild
    isOrphan
    isCoachingLoggedInUser
    canModifyCoaches
    nickname
    hideVisual
    joined
    points
    countVideosCompleted
    bio
    profile {
      accessLevel
      __typename
    }
    soundOn
    muteVideos
    showCaptions
    prefersReducedMotion
    noColorInVideos
    newNotificationCount
    canHellban: hasPermission(name: "can_ban_users", scope: GLOBAL)
    canMessageUsers: hasPermission(
      name: "can_send_moderator_messages"
      scope: GLOBAL
    )
    isSelf: isActor
    hasStudents: hasCoachees
    hasClasses
    hasChildren
    hasCoach
    badgeCounts
    homepageUrl
    isMidsignupPhantom
    includesDistrictOwnedData
    includesKmapDistrictOwnedData
    includesK4dDistrictOwnedData
    canAccessDistrictsHomepage
    preferredKaLocale {
      id
      kaLocale
      status
      __typename
    }
    underAgeGate {
      parentEmail
      daysUntilCutoff
      approvalGivenAt
      __typename
    }
    authEmails
    signupDataIfUnverified {
      email
      emailBounced
      __typename
    }
    pendingEmailVerifications {
      email
      __typename
    }
    hasAccessToAIGuideTeacher
    hasAccessToAIGuideDistrictAdmin
    tosAccepted
    shouldShowAgeCheck
    birthMonthYear
    lastLoginCountry
    region
    userDistrictInfos {
      id
      isKAD
      district {
        id
        region
        __typename
      }
      __typename
    }
    schoolAffiliation {
      id
      location
      __typename
    }
    __typename
  }
  actorIsImpersonatingUser
  isAIGuideEnabled
  hasAccessToAIGuideDev
}`)(We||(We={}));function Pe(t,r){return g(`${f}/getFullUserProfile`,We.query,typeof t=="string"?P(t)?{kaid:t}:{username:t}:t,r)}var Ye;(r=>r.query=`query getProfileWidgets($kaid: String!) {
  user(kaid: $kaid) {
    id
    kaid
    badgeCounts
    isChild
    profile {
      programs {
        id
        authorKaid
        authorNickname
        deleted
        displayableSpinoffCount
        imagePath
        key
        sumVotesIncremented
        translatedTitle: title
        url
        __typename
      }
      __typename
    }
    programs(sort: TOP, pageInfo: {itemsPerPage: 2}) {
      programs {
        id
        authorKaid
        authorNickname
        deleted
        displayableSpinoffCount
        imagePath
        key
        sumVotesIncremented
        translatedTitle: title
        url
        __typename
      }
      __typename
    }
    __typename
  }
  userSummary(kaid: $kaid) {
    statistics {
      answers
      comments
      flags
      projectanswers
      projectquestions
      questions
      replies
      votes
      __typename
    }
    __typename
  }
}`)(Ye||(Ye={}));function Re(t,r){return g(`${f}/getProfileWidgets`,Ye.query,typeof t=="string"&&P(t)?{kaid:t}:t,r)}var Je;(r=>r.query=`query getUserByUsernameOrEmail($username: String, $email: String) {
  user(username: $username, email: $email) {
    id
    kaid
    __typename
  }
}`)(Je||(Je={}));function Se(t,r){return g(`${f}/getUserByUsernameOrEmail`,Je.query,typeof t=="string"?F(t)?{email:t}:{username:t}:t,r)}var ze;(r=>r.query=`query getUserHoverCardProfile($kaid: String!) {
  user(kaid: $kaid) {
    id
    nickname
    username
    bio
    avatar {
      name
      imageSrc
      __typename
    }
    points
    isPhantom
    isActor
    isCoachedByActor
    userSummaryIsVisibleToActor
    actorHasUserScopedPermission(capability: CAN_VIEW_USER_IDENTITY)
    __typename
  }
}`)(ze||(ze={}));function xe(t,r){return g(`${f}/getUserHoverCardProfile`,ze.query,typeof t=="string"?{kaid:t}:t,r)}var Ze;(r=>r.query=`query hotlist($curationNodeId: String, $onlyOfficialProjectSpinoffs: Boolean!, $sort: ListProgramSortOrder, $pageInfo: ListProgramsPageInfo, $userAuthoredContentTypes: [UserAuthoredContentType!]) {
  listTopPrograms(
    curationNodeId: $curationNodeId
    onlyOfficialProjectSpinoffs: $onlyOfficialProjectSpinoffs
    sort: $sort
    pageInfo: $pageInfo
    userAuthoredContentTypes: $userAuthoredContentTypes
  ) {
    complete
    cursor
    programs {
      id
      key
      authorKaid
      authorNickname
      displayableSpinoffCount
      imagePath
      sumVotesIncremented
      translatedTitle: title
      url
      userAuthoredContentType
      __typename
    }
    __typename
  }
}`)(Ze||(Ze={}));function Ae(t,r){return g(`${f}/hotlist`,Ze.query,t,r)}var Xe;(r=>r.query=`query programQuery($programId: String!) {
  programById(id: $programId) {
    byChild
    category
    created
    creatorProfile: author {
      id
      nickname
      profileRoot
      profile {
        accessLevel
        __typename
      }
      __typename
    }
    deleted
    description
    spinoffCount: displayableSpinoffCount
    docsUrlPath
    flags
    flaggedBy: flaggedByKaids
    flaggedByUser: isFlaggedByCurrentUser
    height
    hideFromHotlist
    id
    imagePath
    isProjectOrFork: originIsProject
    isOwner
    kaid: authorKaid
    key
    newUrlPath
    originScratchpad: originProgram {
      deleted
      translatedTitle
      url
      __typename
    }
    restrictPosting
    revision: latestRevision {
      id
      code
      configVersion
      created
      editorType
      folds
      __typename
    }
    slug
    sumVotesIncremented
    title
    topic: parentCurationNode {
      id
      nodeSlug: slug
      relativeUrl
      slug
      translatedTitle
      __typename
    }
    translatedTitle
    url
    userAuthoredContentType
    upVoted
    width
    __typename
  }
}`)(Xe||(Xe={}));function Ie(t,r){return g(`${f}/programQuery`,Xe.query,typeof t=="number"?{programId:t.toString()}:typeof t=="string"?{programId:t}:t,r)}var er;(r=>r.query=`query projectsAuthoredByUser($kaid: String, $pageInfo: ListProgramsPageInfo, $sort: ListProgramSortOrder) {
  user(kaid: $kaid) {
    id
    programs(pageInfo: $pageInfo, sort: $sort) {
      complete
      cursor
      programs {
        id
        key
        authorKaid
        authorNickname
        displayableSpinoffCount
        imagePath
        sumVotesIncremented
        translatedTitle: title
        url
        __typename
      }
      __typename
    }
    __typename
  }
}`)(er||(er={}));function Ee(t,r){return g(`${f}/projectsAuthoredByUser`,er.query,t,r)}var rr;(r=>r.query=`query QAExpandKeyInfo($encryptedKey: String) {
  qaExpandKeyInfo(encryptedQaExpandKey: $encryptedKey) {
    feedbackType
    unencryptedKey
    __typename
  }
}`)(rr||(rr={}));function Te(t,r){return g(`${f}/QAExpandKeyInfo`,rr.query,typeof t=="string"?{encryptedKey:t}:t,r)}var Br={};kr(Br,{LoginWithPasswordMutation:()=>te,loginWithPasswordMutation:()=>Ue});var te;(e=>{e.query=`mutation loginWithPasswordMutation($identifier: String!, $password: String!) {
  loginWithPassword(identifier: $identifier, password: $password) {
    user {
      id
      kaid
      canAccessDistrictsHomepage
      isTeacher
      hasUnresolvedInvitations
      transferAuthToken
      preferredKaLocale {
        id
        kaLocale
        status
        __typename
      }
      __typename
    }
    isFirstLogin
    error {
      code
      __typename
    }
    __typename
  }
}`;let r;(n=>(n.INVALID_CREDENTIALS="INVALID_CREDENTIALS",n.TOO_MANY_ATTEMPTS="TOO_MANY_ATTEMPTS"))(r=e.ErrorCode||(e.ErrorCode={}))})(te||(te={}));function Ue(t,r){return g(`${f}/loginWithPasswordMutation`,te.query,t,{headers:{"x-ka-fkey":lr,Cookie:`fkey=${lr}`},...r})}var H=class{constructor(r,e){return r instanceof h?this.client=r:e??(e=r),e&&this.copy(e),this}copy(r){return Object.assign(this,r),this}copyFromSchema(r){return this.rawData={...this.rawData,...r},this.copy(this.transformSchema(r))}isSchema(r){return this.is(this.transformSchema(r))}};var bt=(r=>(r.DOWNSTREAM_SERVICE_ERROR="DOWNSTREAM_SERVICE_ERROR",r))(bt||{}),kt=(r=>(r.users="users",r))(kt||{}),wt=(e=>(e.COACH="COACH",e.PUBLIC="PUBLIC",e))(wt||{}),Nr=(s=>(s.pjs="pjs",s.webpage="webpage",s.ace_sql="ace_sql",s.unknown="",s))(Nr||{}),ur=(n=>(n.Challenge="Challenge",n.Interactive="Interactive",n.Project="Project",n.Scratchpad="Scratchpad",n.Talkthrough="Talkthrough",n))(ur||{}),tr=(y=>(y.ALL_PROJECT_ANSWER="ALL_PROJECT_ANSWER",y.ALL_PROJECT_QUESTION="ALL_PROJECT_QUESTION",y.ANSWER="ANSWER",y.COMMENT="COMMENT",y.PROGRAM="PROGRAM",y.PROJECTFEEDBACK="PROJECTFEEDBACK",y.PROJECT_CRITIQUE_ANSWER="PROJECT_CRITIQUE_ANSWER",y.PROJECT_CRITIQUE_QUESTION="PROJECT_CRITIQUE_QUESTION",y.PROJECT_EVAL_ANSWER="PROJECT_EVAL_ANSWER",y.PROJECT_EVAL_QUESTION="PROJECT_EVAL_QUESTION",y.PROJECT_HELP_ANSWER="PROJECT_HELP_ANSWER",y.PROJECT_HELP_QUESTION="PROJECT_HELP_QUESTION",y.QUESTION="QUESTION",y.REPLY="REPLY",y.SUGGESTED_CLARIFICATION="SUGGESTED_CLARIFICATION",y))(tr||{}),_t=(s=>(s.AnswerFeedback="AnswerFeedback",s.BasicFeedback="BasicFeedback",s.LowQualityFeedback="LowQualityFeedback",s.QuestionFeedback="QuestionFeedback",s))(_t||{}),Qr=(a=>(a[a.TopVoted=1]="TopVoted",a[a.Recent=2]="Recent",a[a.Trending=5]="Trending",a))(Qr||{}),$r=(l=>(l.TOP="TOP",l.RECENT="RECENT",l.HOT="HOT",l.OFFICIAL="OFFICIAL",l.UPVOTE="UPVOTE",l.OLDEST="OLDEST",l))($r||{});var z,me,ar=class ar extends H{constructor(){super(...arguments);U(this,z)}get url(){return this.kaid?`https://www.khanacademy.org/profile/${this.username??this.kaid}`:null}static fromSchema(e){let a=new ar;return a.copyFromSchema(e),a.rawData=e,a}static fromIdentifier(e){return new ar({kaid:P(e)?e:void 0,username:!P(e)&&!F(e)?e:void 0,email:F(e)?e:void 0})}transformSchema(e){return{emails:e.authEmails??void 0,badgeCounts:e.badgeCounts?JSON.parse(e.badgeCounts):void 0,bio:e.bio??void 0,canAccessDistrictsHomepage:e.canAccessDistrictsHomepage??void 0,canHellban:e.canHellban??void 0,canMessageUsers:e.canMessageUsers??void 0,canModifyCoaches:e.canModifyCoaches??void 0,completedVideos:e.countVideosCompleted,email:e.email??void 0,hasAccessToAIGuideDev:e.hasAccessToAIGuideDev??void 0,hasAccessToAIGuideTeacher:e.hasAccessToAIGuideTeacher??void 0,hasChildren:e.hasChildren??void 0,hasClasses:e.hasClasses??void 0,hasCoach:e.hasCoach??void 0,hasStudents:e.hasStudents??void 0,child:e.isChild??void 0,creator:e.isCreator??void 0,curator:e.isCurator??void 0,developer:e.isDeveloper??void 0,midsignupPhantom:e.isMidsignupPhantom??void 0,moderator:e.isModerator??void 0,orphan:e.isOrphan??void 0,parent:e.isParent??void 0,phantom:e.isPhantom??void 0,publisher:e.isPublisher??void 0,self:e.isSelf??void 0,teacher:e.isTeacher??void 0,formalTeacher:e.isFormalTeacher??void 0,joined:e.joined?new Date(e.joined):void 0,kaid:typeof e.kaid=="string"&&P(e.kaid)?e.kaid:typeof e.kaid=="string"?null:void 0,key:e.key??void 0,newNotifications:e.newNotificationCount??void 0,nickname:e.nickname??void 0,points:e.points??void 0,accessLevel:e.profile?.accessLevel,googleID:typeof e.userId=="string"&&qr(e.userId)?e.userId.match(He)[1]:typeof e.userId=="string"?null:void 0,qualarooID:typeof e.qualarooId=="string"&&Or(e.qualarooId)?e.qualarooId.match(je)[1]:typeof e.qualarooId=="string"?null:void 0,username:e.username??(e.profileRoot?P(e.profileRoot.slice(9,-1))?null:e.profileRoot.slice(9,-1):e.username)}}async get(e=this.client??new h){let a=await e.getUser(m(this,z,me).call(this));return this.copy(a)}async getAvatar(e=this.client??new h){let a=await e.getUserAvatar(m(this,z,me).call(this));return this.copy({avatar:a}),a}async getStatistics(e=this.client??new h){let a=await e.getUserStatistics(m(this,z,me).call(this));return this.copy({statistics:a})}async*getPrograms(e=this.client??new h,a,s){for await(let n of e.getUserPrograms(m(this,z,me).call(this),a,s))this.programs||this.copy({programs:[]}),this.programs?.push(...n),yield n;return this}async getAllPrograms(e=this.client??new h,a,s){let n=await e.getAllUserPrograms(m(this,z,me).call(this),a,s);return this.copy({programs:n})}is(e){return!(this.kaid&&e.kaid)&&!(this.email&&e.email)&&!(this.key&&e.key)&&!(this.username&&e.username)&&!(this.googleID&&e.googleID)&&!(this.qualarooID&&e.qualarooID)?(console.warn("Users don't have any identifiers that can be compared"),!1):this.kaid&&e.kaid&&this.kaid===e.kaid||this.email&&e.email&&this.email===e.email||this.key&&e.key&&this.key===e.key||this.username&&e.username&&this.username===e.username||this.googleID&&e.googleID&&this.googleID===e.googleID||this.qualarooID&&e.qualarooID&&this.qualarooID===e.qualarooID||!1}};z=new WeakSet,me=function(){if(this.kaid)return this.kaid;if(this.username)return this.username;if(this.email)return this.email;throw new Error("User has no identifier")};var N=ar;function Pt(t){return"data"in t&&!("errors"in t)}function Rt(t){return"errors"in t&&Array.isArray(t.errors)&&"data"in t}function St(t){return"errors"in t&&Array.isArray(t.errors)&&!("data"in t)}function A(t){if(Rt(t))throw new Error("Expected data response but got service errors response: "+t.errors.map(r=>r.message).join(", "));if(St(t))throw new Error("Expected data response but got input errors response: "+t.errors.map(r=>r.message).join(", "));if(!Pt(t))throw new Error("Expected data response but got unknown response")}function Gr(t){if(!ue(t))throw new Error("Invalid program key");let r=atob($e(t)).split("").map(s=>s.charCodeAt(0)),e=r[17];if(e===20)r=r.slice(32,37);else if(e===23)r=r.slice(34,40);else throw new Error(`Unknown program key version: ${e}`);let a=0n;for(let s=0;s<r.length;s++)a|=BigInt(r[s]&127)<<BigInt(s*7);return Number(e===20?a:a<<14n)}function Ko(t){if(!re(t))throw new Error("Invalid program ID");typeof t=="string"&&(t=parseInt(t));let r=t.toString(2).match(/.{1,7}(?=(.{7})*$)/g).map(a=>String.fromCharCode(parseInt(a.length===7?`1${a}`:a,2))).reverse().join(""),e=btoa(`js~khan-academyr${r.length===5?"":""}\v
Scratchpad${r}\f`);return e=Er(e),e}async function mr(t){if(P(t))return t;if(P(`kaid_${t}`))return`kaid_${t}`;if(pe(t)){let s=t.match(_e);if(!s)throw new Error("Invalid user URL");if(t=s[1],P(t))return t}let e=await(await Se(t)).json();if(A(e),!e.data.user)throw new Error("User not found");let a=e.data.user.kaid;if(!P(a))throw new Error("Invalid KAID");return a}async function Hr(t){if(!P(t)&&!F(t)&&!pe(t))return t;if(pe(t)){let a=t.match(_e);if(!a)throw new Error("Invalid user URL");if(t=a[1],!P(t)&&!F(t))return t}P(t)||(t=await mr(t));let e=await(await xe(t)).json();if(A(e),!e.data.user)throw new Error("User not found");return e.data.user.username}function ve(t){if(typeof t=="number"){if(!re(t))throw new Error("Invalid program ID");return t}else if(Dr(t)){let r=t.match(ce)[1];if(!re(r))throw new Error("Invalid program URL");return parseInt(r,10)}else if(ue(t)){if(t=Gr(t),!re(t))throw new Error("Invalid program key");return t}else if(typeof t=="string"){if(!re(t))throw new Error("Invalid program ID");return parseInt(t,10)}throw new Error("Invalid program identifier")}async function jr(t){if(I(t))return t;if(!D(t))throw new Error("Invalid encrypted message key");let e=await(await Te(t)).json();if(A(e),!e.data.qaExpandKeyInfo)throw new Error("Message key not found");return e.data.qaExpandKeyInfo.unencryptedKey}var Wr=(s=>(s.ProcessingJS="pjs",s.HTML="webpage",s.SQL="ace_sql",s.Other="",s))(Wr||{}),j,ae,Q=class Q extends H{constructor(){super(...arguments);U(this,j)}get spinoff(){return typeof this.origin<"u"?!!this.origin:null}get lines(){return this.code?this.code.split(`
`).length:null}get url(){return this.rawData?.url?`https://www.khanacademy.org${this.rawData.url}`:this.id?`https://www.khanacademy.org/computer-programming/-/${this.id}`:null}get shortUrl(){return this.id?`https://khanacademy.org/cs/-/${this.id}`:null}get thumbnailUrl(){return this.rawData?.imagePath?`https://www.khanacademy.org${this.rawData.imagePath}`:this.thumbnailID&&this.url?`${this.url}/${this.thumbnailID}.png`:null}static fromSchema(e){let a=new Q;return a.copyFromSchema(e),a.rawData=e,a}static fromIdentifier(e){let a=ve(e);return new Q({id:a,key:typeof e=="string"&&ue(e)?e:void 0})}transformSchema(e){return{id:e.id?parseInt(e.id,10):void 0,title:e.translatedTitle,author:e.authorKaid||e.authorNickname||e.creatorProfile?N.fromSchema({kaid:e.authorKaid,nickname:e.authorNickname,isChild:e.byChild??void 0,...e.creatorProfile}):void 0,created:(()=>{if(e.created)return e.revision?.created?new Date(Math.min(new Date(e.created).valueOf(),new Date(e.revision.created).valueOf())):new Date(e.created)})(),updated:(()=>{if(e.revision?.created)return e.created&&e.revision.created===e.created?null:new Date(e.revision.created)})(),width:e.width,height:e.height,votes:e.sumVotesIncremented,spinOffCount:e.spinoffCount??e.displayableSpinoffCount,code:e.revision?.code,hidden:e.hideFromHotlist,type:(()=>{switch(e.revision?.editorType){case"pjs":return Q.Type.ProcessingJS;case"webpage":return Q.Type.HTML;case"ace_sql":return Q.Type.SQL;default:return Q.Type.Other}})(),origin:(()=>{if(!e.originScratchpad)return e.originScratchpad;let a=("https://khanacademy.org"+e.originScratchpad.url).match(ce)?.[1];if(!a){console.error(`Failed to parse origin program ID from URL: ${e.originScratchpad.url}`);return}return new Q({id:parseInt(a,10),title:e.originScratchpad.translatedTitle,deleted:e.originScratchpad.deleted})})(),key:e.key,thumbnailID:e.imagePath&&Ge.test(e.imagePath)?parseInt(e.imagePath.match(Ge)[1],10):void 0,description:typeof e.description=="string"?e.description!==""?e.description:null:e.description,deleted:e.deleted??void 0,selfFlagged:e.flaggedByUser,selfVoted:e.upVoted}}async get(e=this.client??new h){if(!this.id&&!this.key)throw new Error("Program is missing ID and key");let a=await e.getProgram(this.id??this.key);return this.copy(a)}async*getTipsAndThanks(e=this.client??new h,a){for await(let s of e.getProgramTipsAndThanks(m(this,j,ae).call(this),a))this.tipsAndThanks||this.copy({tipsAndThanks:[]}),s.forEach(n=>this.tipsAndThanks?.push(n)),yield s;return this}async getAllTipsAndThanks(e=this.client??new h,a){let s=await e.getAllProgramTipsAndThanks(m(this,j,ae).call(this),a);return this.copy({tipsAndThanks:s})}async*getQuestions(e=this.client??new h,a){for await(let s of e.getProgramQuestions(m(this,j,ae).call(this),a))this.questions||this.copy({questions:[]}),s.forEach(n=>this.questions.push(n)),yield s;return this}async getAllQuestions(e=this.client??new h,a){let s=await e.getAllProgramQuestions(m(this,j,ae).call(this),a);return this.copy({questions:s})}async*getHelpRequests(e=this.client??new h,a){for await(let s of e.getProgramHelpRequests(m(this,j,ae).call(this),a))this.helpRequests||this.copy({helpRequests:[]}),s.forEach(n=>this.helpRequests.push(n)),yield s;return this}async getAllHelpRequests(e=this.client??new h,a){let s=await e.getAllProgramHelpRequests(m(this,j,ae).call(this),a);return this.copy({helpRequests:s})}is(e){return!(this.id&&e.id)&&!(this.key&&e.key)?(console.warn("Programs don't have any identifiers that can be compared"),!1):this.id&&e.id&&this.id===e.id||this.key&&e.key&&this.key===e.key||!1}};j=new WeakSet,ae=function(){if(this.id)return this.id;if(this.key)return this.key;throw new Error("Program has no identifier")},Q.Type=Wr;var O=Q;var Yr=["blobby_green_style","blobby_yellow_style","blobby_blue_style","blobby_purple_style","area_52_yellow_style","area_52_blue_style","area_52_green_style","area_52_purple_style","eggleston_blue_style","eggleston_yellow_style","eggleston_green_style","eggleston_orange_style","scuttlebug_purple_style","scuttlebug_yellow_style","scuttlebug_blue_style","scuttlebug_green_style","boggle_yellow_style","boggle_blue_style","boggle_green_style","boggle_purple_style","sneak_peak_green_style","sneak_peak_yellow_style","sneak_peak_blue_style","sneak_peak_purple_style","stelly_blue_style","stelly_yellow_style","stelly_green_style","stelly_orange_style","cacteye_purple_style","cacteye_yellow_style","cacteye_blue_style","cacteye_green_style","leaf_green_style","leaf_blue_style","leaf_grey_style","leaf_red_style","leaf_orange_style","leaf_yellow_style","leafers_seed_style","leafers_seedling_style","leafers_sapling_style","leafers_tree_style","leafers_ultimate_style","piceratops_seed_style","piceratops_seedling_style","piceratops_sapling_style","piceratops_tree_style","piceratops_ultimate_style","duskpin_seed_style","duskpin_seedling_style","duskpin_sapling_style","duskpin_tree_style","duskpin_ultimate_style","primosaur_seed_style","primosaur_seedling_style","primosaur_sapling_style","primosaur_tree_style","primosaur_ultimate_style","starky_seed_style","starky_seedling_style","starky_sapling_style","starky_tree_style","starky_ultimate_style","aqualine_seed_style","aqualine_seedling_style","aqualine_sapling_style","aqualine_tree_style","aqualine_ultimate_style","spunky_sam_blue_style","spunky_sam_green_style","spunky_sam_orange_style","spunky_sam_red_style","marcimus_pink_style","marcimus_orange_style","marcimus_red_style","marcimus_purple_style","mr_pink_red_style","mr_pink_green_style","mr_pink_orange_style","female_robot_amelia_style","female_robot_ada_style","female_robot_grace_style","male_robot_johnny_style","male_robot_donald_style","male_robot_hal_style","orange_juice_squid_orange_style","purple_pi_purple_style","purple_pi_pink_style","purple_pi_teal_style","mr_pants_teal_style","mr_pants_green_style","mr_pants_orange_style","mr_pants_pink_style","mr_pants_purple_style","old_spice_man_green_style","old_spice_man_blue_style","winston_default_style","winston_baby_style","ohnoes_default_style","hopper_happy_style","hopper_jumping_style","hopper_cool_style"],Jr=["blobby-green","blobby-yellow","blobby-blue","blobby-purple","area-52-yellow","area-52-blue","area-52-green","area-52-purple","eggleston-blue","eggleston-yellow","eggleston-green","eggleston-orange","scuttlebug-purple","scuttlebug-yellow","scuttlebug-blue","scuttlebug-green","boggle-yellow","boggle-blue","boggle-green","boggle-purple","sneak-peak-green","sneak-peak-yellow","sneak-peak-blue","sneak-peak-purple","stelly-blue","stelly-yellow","stelly-green","stelly-orange","cacteye-purple","cacteye-yellow","cacteye-blue","cacteye-green","leaf-green","leaf-blue","leaf-grey","leaf-red","leaf-orange","leaf-yellow","leafers-seed","leafers-seedling","leafers-sapling","leafers-tree","leafers-ultimate","piceratops-seed","piceratops-seedling","piceratops-sapling","piceratops-tree","piceratops-ultimate","duskpin-seed","duskpin-seedling","duskpin-sapling","duskpin-tree","duskpin-ultimate","primosaur-seed","primosaur-seedling","primosaur-sapling","primosaur-tree","primosaur-ultimate","starky-seed","starky-seedling","starky-sapling","starky-tree","starky-ultimate","aqualine-seed","aqualine-seedling","aqualine-sapling","aqualine-tree","aqualine-ultimate","spunky-sam","spunky-sam-green","spunky-sam-orange","spunky-sam-red","marcimus","marcimus-orange","marcimus-red","marcimus-purple","mr-pink","mr-pink-green","mr-pink-orange","robot_female_1","robot_female_2","robot_female_3","robot_male_1","robot_male_2","robot_male_3","orange-juice-squid","purple-pi","purple-pi-pink","purple-pi-teal","mr-pants","mr-pants-green","mr-pants-orange","mr-pants-pink","mr-pants-purple","old-spice-man","old-spice-man-blue","cs-winston","cs-winston-baby","cs-ohnoes","cs-hopper-happy","cs-hopper-jumping","cs-hopper-cool"];function Jo(t){return Jr[Yr.indexOf(t)]}function zo(t){return Yr[Jr.indexOf(t)]}function yr(t){return`https://www.khanacademy.org/images/avatars/svg/${t}.svg`}function fr(t){return`https://www.khanacademy.org/images/avatars/${t}.png`}function or(t){return t.match(/^(?:https:\/\/www\.khanacademy\.org)?\/images\/avatars(?:\/svg)?\/(.*)\.(?:(?:svg)|(?:png))$/)?.[1]??null}function Zo(t){let r=or(t);return r?fr(r):null}function Xo(t){let r=or(t);return r?yr(r):null}function zr(t){return t.replace(/[a-zA-Z]+, \d\d [A-Za-z0-9]+ \d{4} \d\d:\d\d:\d\d [a-zA-Z]+/g,"").replace(/; (Path|Expires|Max-Age|HttpOnly|Secure|SameSite)[^;,]*/g,"").replace(/,/g,";")}var Z=class extends H{get bySelf(){return this.client?.user?this.byUser(this.client.user):!1}get url(){if(!this.program?.url||!this.encryptedKey)return null;let r={qa_expand_key:this.key??this.encryptedKey,qa_expand_type:this.rawData?.feedbackType?.toLowerCase()},e=new URL(this.program.url);for(let[a,s]of Object.entries(r))s&&e.searchParams.set(a,s);return e.toString()}transformSchema(r){return{text:r.content,author:r.author&&N.fromSchema(r.author),program:(()=>{if(r.focus?.kind==="Scratchpad")return new O({id:typeof r.focus.id=="string"?parseInt(r.focus.id,10):void 0,title:r.focus.translatedTitle});if(r.focusUrl){let e=r.focusUrl.match(vr);return!e||e.length<1?void 0:new O({id:parseInt(e[1],10)})}})(),created:r.date?new Date(r.date):void 0,key:r.expandKey,encryptedKey:r.key,deleted:r.appearsAsDeleted,locked:r.isLocked,pinned:r.isPinned,verified:r.definitelyNotSpam,score:r.lowQualityScore,byVideoAuthor:r.fromVideoAuthor,selfFlagged:r.flaggedByUser}}byUser(r){return this.author?this.author.is(r):!1}is(r){return!(this.key&&r.key)&&!(this.encryptedKey&&r.encryptedKey)?(console.warn("Messages don't have any identifiers that can be compared"),!1):this.key&&r.key&&this.key===r.key||this.encryptedKey&&r.encryptedKey&&this.encryptedKey===r.encryptedKey||!1}};var ye=(a=>(a[a.TipsAndThanks="COMMENT"]="TipsAndThanks",a[a.Question="QUESTION"]="Question",a[a.HelpRequest="PROJECT_HELP_QUESTION"]="HelpRequest",a))(ye||{}),De,gr,Ke=class Ke extends Z{constructor(){super(...arguments);U(this,De)}get selfVoted(){return this.client?.authenticated===!1?null:this.selfUpvoted?1:this.selfDownvoted?-1:0}static fromSchema(e){let a=new Ke;return a.copyFromSchema(e),a.rawData=e,a}static fromIdentifier(e){return new Ke({key:I(e)?e:void 0,encryptedKey:D(e)?e:void 0})}transformSchema(e){return{...super.transformSchema(e),votes:e.sumVotesIncremented,replyCount:e.replyCount,selfUpvoted:e.upVoted,selfDownvoted:e.downVoted}}copy(e){return super.copy(e)}async get(e=this.client??new h){let a=await e.getMessage(m(this,De,gr).call(this));return this.copy(a)}async*getReplies(e=this.client??new h,a){for await(let s of e.getMessageReplies(m(this,De,gr).call(this),a))this.replies||this.copy({replies:[]}),this.replies?.push(...s),yield s;return this}async getAllReplies(e=this.client??new h){if(!this.key&&!this.encryptedKey)throw new Error("Message does not have a key or encrypted key");let a=await e.getAllMessageReplies(this.key??this.encryptedKey);return this.copy({replies:a})}};De=new WeakSet,gr=function(){if(this.key)return this.key;if(this.encryptedKey)return this.encryptedKey;throw new Error("Message does not have a key or encrypted key")},Ke.Type=ye;var R=Ke;var fe=class t extends R{static fromSchema(r){let e=new t;return e.copyFromSchema(r),e.rawData=r,e}static fromIdentifier(r){return new t({key:I(r)?r:void 0,encryptedKey:D(r)?r:void 0})}transformSchema(r){return{...super.transformSchema(r),question:r.question?M.fromSchema(r.question):void 0}}copy(r){return super.copy(r)}};var M=class t extends R{static fromSchema(r){let e=new t;return e.copyFromSchema(r),e.rawData=r,e}static fromIdentifier(r){return new t({key:I(r)?r:void 0,encryptedKey:D(r)?r:void 0})}transformSchema(r){return{...super.transformSchema(r),answerCount:r.answerCount,old:r.isOld,answers:(()=>{if(!r.answers)return;let e=r.answers.map(a=>fe.fromSchema(a));return e.forEach(a=>a.copy({question:this})),e})()}}copy(r){return super.copy(r)}};var X=class t extends Z{static fromSchema(r){let e=new t;return e.copyFromSchema(r),e.rawData=r,e}static fromIdentifier(r){return new t({key:I(r)?r:void 0,encryptedKey:D(r)?r:void 0})}transformSchema(r){return{...super.transformSchema(r),message:(()=>{if(!(typeof r.replyExpandKeys>"u")){if(typeof r.replyExpandKeys=="string"&&I(r.replyExpandKeys))return new R({key:r.replyExpandKeys});if(Array.isArray(r.replyExpandKeys))return new R({key:r.replyExpandKeys[0]})}})()}}copy(r){return super.copy(r)}copyFromSchema(r){return super.copyFromSchema(r)}async get(r=this.client??new h){if(!this.key&&!this.encryptedKey)throw new Error("Message does not have a key or encrypted key");let e=await r.getMessage(this.key??this.encryptedKey);return this.copy(e)}};var ee=class t extends R{static fromSchema(r){let e=new t;return e.copyFromSchema(r),e.rawData=r,e}static fromIdentifier(r){return new t({key:I(r)?r:void 0,encryptedKey:D(r)?r:void 0})}transformSchema(r){return{...super.transformSchema(r),votes:r.sumVotesIncremented,replyCount:r.replyCount,selfUpvoted:r.upVoted,selfDownvoted:r.downVoted}}copy(r){return super.copy(r)}};function Zr(t){return t.feedbackType==="COMMENT"}function Ms(t){return t.feedbackType==="REPLY"}function Xr(t){return t.feedbackType==="QUESTION"||t.feedbackType==="PROJECT_HELP_QUESTION"}function Vs(t){return t.feedbackType==="ANSWER"}var et={[ye.TipsAndThanks]:ee,[ye.Question]:M,[ye.HelpRequest]:M};var W,oe,se,$,ge,he,T,v,E=class E{constructor(){U(this,W);U(this,oe);U(this,se);U(this,$,new Map);U(this,ge,new Map);U(this,he,new Map);this.authenticated=!1;this.kaid=null;return this}async resolveCachedKaid(r){if(P(r))return r;if(b(this,$).has(r))return b(this,$).get(r);let e=await mr(r);return b(this,$).set(r,e),e}async resolveCachedUsername(r){if(!P(r)&&!F(r)&&!pe(r))return r;if(b(this,ge).has(r))return b(this,ge).get(r);let e=await Hr(r);return b(this,ge).set(r,e),e}async resolveCachedFeedbackKey(r){if(I(r))return r;if(b(this,he).has(r))return b(this,he).get(r);let e=await jr(r);return b(this,he).set(r,e),e}get kaas(){return!this.authenticated||!b(this,se)?null:b(this,se).match(/KAAS=([^;]+)/)?.[1]??null}async login(r,e){var l;if(r&&(P(r)&&(r=await this.resolveCachedUsername(r)),Le(this,W,r)),e&&Le(this,oe,e),!b(this,W)||!b(this,oe))throw b(this,W)?b(this,oe)?new Error("Missing username/email and password"):new Error("Missing password"):new Error("Missing username or email");let a=await Ue({identifier:b(this,W),password:b(this,oe)},{credentials:"include"}),s=await m(l=E,T,v).call(l,a);if(A(s),!s.data.loginWithPassword)throw new Error("Malformed response");if(s.data.loginWithPassword.error)switch(s.data.loginWithPassword.error.code){case te.ErrorCode.INVALID_CREDENTIALS:throw new Error("Invalid Credentials error: Check your username/email and password");case te.ErrorCode.TOO_MANY_ATTEMPTS:throw new Error("Too Many Attempts error: Rate-limited by Khan Academy");default:throw new Error("Unknown error code: "+s.data.loginWithPassword.error.code)}let n=a.headers.get("set-cookie");if(!n)throw new Error("No cookies returned: Something went wrong on Khan Academy's end");return Le(this,se,zr(n)),this.authenticated=!0,this.kaid=typeof s.data.loginWithPassword.user?.kaid=="string"&&P(s.data.loginWithPassword.user.kaid)?s.data.loginWithPassword.user.kaid:null,this.kaid===null&&console.warn(`User ${r??this.kaas??"unknown"} does not have a valid KAID`),this}async getUser(r){var l;if(!r&&!this.authenticated)throw new Error("Not authenticated: You need to login or provide an indentifier");let e=null;r&&(F(r)&&(e=r),r=await this.resolveCachedKaid(r));let a=await Pe(r,r?void 0:{credentials:"include",headers:{cookie:b(this,se)}}),s=await m(l=E,T,v).call(l,a);if(A(s),!s.data.user)throw new Error("User not found");let n=N.fromSchema(s.data.user);return n.client=this,!n.email&&e&&F(e)&&n.copy({email:e}),n.self&&(this.user=n),n.kaid&&(n.username&&!b(this,$).has(n.username)&&b(this,$).set(n.username,n.kaid),n.email&&!b(this,$).has(n.email)&&b(this,$).set(n.email,n.kaid)),n}async getUserAvatar(r=this.kaid??b(this,W),e="svg"){var l;if(!r)throw new Error("No identifier provided");r=await this.resolveCachedKaid(r);let a=await ke(r),s=await m(l=E,T,v).call(l,a);if(A(s),!s.data.user)throw new Error("User not found");let n=or(s.data.user.avatar.imageSrc);if(!n)throw new Error("User has no avatar");return e==="svg"?yr(n):fr(n)}async getUserStatistics(r=this.kaid??b(this,W)){var s;if(!r)throw new Error("No identifier provided");r=await this.resolveCachedKaid(r);let e=await Re(r),a=await m(s=E,T,v).call(s,e);if(A(a),!a.data.user)throw new Error("User not found");return{votes:a.data.userSummary.statistics.votes,tipsAndThanks:a.data.userSummary.statistics.comments,questions:a.data.userSummary.statistics.questions,answers:a.data.userSummary.statistics.answers,helpRequests:a.data.userSummary.statistics.projectquestions,helpRequestAnswers:a.data.userSummary.statistics.projectanswers,replies:a.data.userSummary.statistics.replies,flags:a.data.userSummary.statistics.flags}}async*getUserPrograms(r,e="TOP",a=40){if(!r&&!this.authenticated)throw new Error("Not authenticated: You need to login or provide an indentifier");if(r??(r=this.kaid??this.user?.username??this.user?.email),!r)throw new Error("Missing identifier for logged in user");let n={kaid:await this.resolveCachedKaid(r),pageInfo:{cursor:null,itemsPerPage:a},sort:e},l=async x=>{var y;let w=await Ee({...n,pageInfo:{...n.pageInfo,cursor:x}}),c=await m(y=E,T,v).call(y,w);if(A(c),!c.data.user)throw new Error("User not found");if(!c.data.user.programs.complete&&!c.data.user.programs.cursor)throw new Error("Cursor not found");let C=c.data.user.programs.programs.map(G=>{let be=O.fromSchema(G);return be.client=this,be}),L=c.data.user.programs.complete?null:c.data.user.programs.cursor;return{programs:C,cursor:L}},{programs:p,cursor:k}=await l();for(yield p;k;)({programs:p,cursor:k}=await l(k)),yield p}async getAllUserPrograms(r,e="TOP",a=100){let s=[];for await(let n of this.getUserPrograms(r,e,a))s.push(...n);return s}async getProgram(r){var n;r=ve(r);let e=await Ie(r),a=await m(n=E,T,v).call(n,e);if(A(a),!a.data.programById)throw new Error("Program not found");let s=O.fromSchema(a.data.programById);return s.client=this,this.user&&s.author?.kaid===this.kaid&&(s.copy({author:this.user}),console.debug(`Copied the client's user data to program ${s.title?`"${Ir(s.title,32)}"`:s.id??"unknown"} because the program's author matches the client user`)),s}async*getHotlistPrograms(r="HOT",e=40,a=!1){let s={onlyOfficialProjectSpinoffs:a,sort:r,pageInfo:{cursor:null,itemsPerPage:e}},n=async k=>{var L;let x=await Ae({...s,pageInfo:{...s.pageInfo,cursor:k}}),w=await m(L=E,T,v).call(L,x);if(A(w),!w.data.listTopPrograms)throw new Error("Programs not found");if(!w.data.listTopPrograms.complete&&!w.data.listTopPrograms.cursor)throw new Error("Cursor not found");let V=w.data.listTopPrograms.programs.map(y=>{let G=O.fromSchema(y);return G.client=this,G}),C=w.data.listTopPrograms.complete?null:w.data.listTopPrograms.cursor;return{programs:V,cursor:C}},{programs:l,cursor:p}=await n();for(yield l;p;)({programs:l,cursor:p}=await n(p)),yield l}async*getTopPrograms(r=40,e=!1){yield*this.getHotlistPrograms("TOP",r,e)}async*getRecentPrograms(r=40,e=!1){yield*this.getHotlistPrograms("RECENT",r,e)}async getMessage(r){var l;I(r)||(r=await this.resolveCachedFeedbackKey(r));let e=await le({topicId:_r.toString(),focusKind:"Scratchpad",feedbackType:"COMMENT",currentSort:1,qaExpandKey:r}),a=await m(l=E,T,v).call(l,e);if(A(a),!a.data.feedback||!a.data.feedback.feedback||a.data.feedback.feedback.length===0)throw new Error("Message not found");let s=a.data.feedback.feedback[0],n;if(Zr(s))n=ee.fromSchema(s);else if(Xr(s)){let p=M.fromSchema(s);if(p.key!==r){let k=p.answers?.find(x=>x.key===r);if(!k)throw new Error("Question or answer not found");n=k,n.copy({question:p})}else n=p}else throw new Error("Unknown message type");return n.client=this,this.user&&n.author?.kaid===this.kaid&&(n.copy({author:this.user}),console.debug(`Copied the client's user data to comment ${n.key??n.encryptedKey??"unknown"} because the comment's author matches the client user`)),n}async getTipsAndThanks(r){return this.getMessage(r)}async getQuestion(r){return this.getMessage(r)}async getAnswer(r){return this.getMessage(r)}async getReply(r){var p;let e=await this.getMessage(r);if(!e.key)throw new Error("Message has no key");let a=await de(e.key),s=await m(p=E,T,v).call(p,a);if(A(s),!s.data.feedbackReplies||s.data.feedbackReplies.length===0)throw new Error("Reply not found");let n=s.data.feedbackReplies.find(k=>k.expandKey===r||k.key===r);if(!n)throw new Error("Reply not found");let l=X.fromSchema(n);return l.client=this,l.copy({message:e}),this.user&&l.author?.kaid===this.kaid&&(l.copy({author:this.user}),console.debug(`Copied the client's user data to reply ${l.key??l.encryptedKey??"unknown"} because the reply's author matches the client user`)),l}async*getProgramMessages(r=R.Type.TipsAndThanks,e,a=1){e=ve(e);let s={topicId:e.toString(),focusKind:"Scratchpad",feedbackType:r,currentSort:a},n=async k=>{var L;let x=await le({...s,cursor:k}),w=await m(L=E,T,v).call(L,x);if(A(w),!w.data.feedback.feedback)throw new Error("Comments not found");if(!w.data.feedback.isComplete&&!w.data.feedback.cursor)throw new Error("Cursor not found");let V=w.data.feedback.feedback.map(y=>{let G=et[r].fromSchema(y);return G.client=this,G}),C=!w.data.feedback.isComplete&&w.data.feedback.cursor;return{messages:V,cursor:C}},{messages:l,cursor:p}=await n();for(yield l;p;)({messages:l,cursor:p}=await n(p)),yield l}async getAllProgramMessages(r=R.Type.TipsAndThanks,e,a=1){let s=[];for await(let n of this.getProgramMessages(r,e,a))s.push(...n);return s}async*getProgramTipsAndThanks(r,e=1){yield*this.getProgramMessages(R.Type.TipsAndThanks,r,e)}async getAllProgramTipsAndThanks(r,e=1){return this.getAllProgramMessages(R.Type.TipsAndThanks,r,e)}async*getProgramQuestions(r,e=1){yield*this.getProgramMessages(R.Type.Question,r,e)}async getAllProgramQuestions(r,e=1){return this.getAllProgramMessages(R.Type.Question,r,e)}async*getProgramHelpRequests(r,e=1){yield*this.getProgramMessages(R.Type.HelpRequest,r,e)}async getAllProgramHelpRequests(r,e=1){return this.getAllProgramMessages(R.Type.HelpRequest,r,e)}async*getMessageReplies(r,e=10){let a={postKey:r,cursor:null,limit:e},s=async p=>{var C;let k=await we({...a,cursor:p}),x=await m(C=E,T,v).call(C,k);if(A(x),!x.data.feedbackRepliesPaginated)throw new Error("Replies not found");if(!x.data.feedbackRepliesPaginated.isComplete&&!x.data.feedbackRepliesPaginated.cursor)throw new Error("Cursor not found");let w=x.data.feedbackRepliesPaginated.feedback;if(!w)return{replies:[],cursor:null};let c=w.map(L=>{let y=X.fromSchema(L);return y.client=this,y}),V=x.data.feedbackRepliesPaginated.isComplete?null:x.data.feedbackRepliesPaginated.cursor;return{replies:c,cursor:V}},{replies:n,cursor:l}=await s();for(yield n;l;)({replies:n,cursor:l}=await s(l)),yield n}async getAllMessageReplies(r){var n;let e=await de(r),a=await m(n=E,T,v).call(n,e);if(A(a),!a.data.feedbackReplies)throw new Error("Replies not found");return a.data.feedbackReplies.map(l=>{let p=X.fromSchema(l);return p.client=this,p})}};W=new WeakMap,oe=new WeakMap,se=new WeakMap,$=new WeakMap,ge=new WeakMap,he=new WeakMap,T=new WeakSet,v=async function(r){try{return await r.json()}catch(e){let a=e instanceof Error?e.message:typeof e=="string"?e:"Unknown error";throw new Error(`Failed to parse response JSON: ${a}`)}},U(E,T);var h=E;var xt=(l=>(l[l.Meteorite=0]="Meteorite",l[l.Moon=1]="Moon",l[l.Earth=2]="Earth",l[l.Sun=3]="Sun",l[l.BlackHole=4]="BlackHole",l[l.Challenge=5]="Challenge",l))(xt||{});export{fe as Answer,xt as BadgeCategory,Z as BaseMessage,h as Client,Mr as EmailRegex,pa as EmailRegexMatch,ur as FeedbackFocusKind,Cr as FeedbackKeyRegex,sa as FeedbackKeyRegexMatch,Qr as FeedbackSort,tr as FeedbackType,_t as FeedbackTypename,He as GoogleIDRegex,la as GoogleIDRegexMatch,pr as KaidRegex,Xt as KaidRegexMatch,$r as ListProgramSortOrder,na as MESSAGE_ENCRYPTED_KEY_LENGTHS,oa as MESSAGE_KEY_LENGTHS,R as Message,Lr as MessageEncryptedKeyRegex,ia as MessageEncryptedKeyRegexMatch,ye as MessageType,gt as PROGRAM_ID_LENGTHS,ht as PROGRAM_KEY_LENGTHS,Kr as PROGRAM_URL_PATHS,O as Program,Nr as ProgramEditorType,cr as ProgramIDRegex,vr as ProgramIDRegexMatch,Ge as ProgramImagePathRegex,ta as ProgramImagePathRegexMatch,Fr as ProgramKeyRegex,aa as ProgramKeyRegexMatch,Wr as ProgramType,ce as ProgramURLRegex,ra as ProgramURLRegexMatch,je as QualarooIDRegex,da as QualarooIDRegexMatch,M as Question,X as Reply,bt as ServiceErrorCode,kt as ServiceErrorName,ee as TipsAndThanks,et as TypeToMessageClass,Ur as URL_LOCALES,Tr as URL_TLDS,N as User,wt as UserAccessLevel,_e as UserURLRegex,ea as UserURLRegexMatch,A as assertDataResponse,Jo as avatarNameToSlug,Yr as avatarNames,zo as avatarSlugToName,Jr as avatarSlugs,Xo as convertAvatarPNGToSVG,Zo as convertAvatarSVGToPNG,or as extractAvatarSlug,fr as generateAvatarPNG,yr as generateAvatarSVG,Ct as get,Ut as getLatestFragment,Sr as getLatestMutation,dr as getLatestQuery,vt as getLatestQueryHash,g as graphql,ft as hashQuery,ie as http,Vs as isAnswerSchema,Pt as isDataResponse,F as isEmail,D as isEncryptedFeedbackKey,I as isFeedbackKey,qr as isGoogleID,St as isInputErrorResponse,P as isKaid,re as isProgramID,ue as isProgramKey,Dr as isProgramURL,Or as isQualarooID,Xr as isQuestionSchema,Ms as isReplySchema,Rt as isServiceErrorsResponse,Zr as isTipsAndThanksSchema,pe as isUserURL,Br as mutations,xr as post,Ko as programIDtoKey,Gr as programKeyToID,Vr as queries,jr as resolveFeedbackKey,mr as resolveKaid,ve as resolveProgramID,Hr as resolveUsername};
//# sourceMappingURL=khan-api.min.js.map
